// ==EMEVD==
// @docs    ds1-common.emedf.json
// @compress    None
// @game    DarkSouls1
// @string    
// @linked    []
// @version    3.2.2
// ==/EMEVD==

// Init
Event(0, Default, function() {
    InitializeEvent(0, 11035000, 0);  // TTT not supported
    
    /* Disable all CTF Lizards, re-enable them if needed. Just a performance tweak to try to help framerates */
    ChangeCharacterEnableState(1039011, Disabled);
    ChangeCharacterEnableState(1038411, Disabled);
    ChangeCharacterEnableState(1039111, Disabled);
    ChangeCharacterEnableState(1039031, Disabled);
    ChangeCharacterEnableState(1038431, Disabled);
    ChangeCharacterEnableState(1039131, Disabled);
    ChangeCharacterEnableState(1038531, Disabled);
    ChangeCharacterEnableState(1038511, Disabled);
    ChangeCharacterEnableState(1038631, Disabled);
    ChangeCharacterEnableState(1038611, Disabled);
    ChangeCharacterEnableState(1038731, Disabled);
    ChangeCharacterEnableState(1038711, Disabled);
    
    /* Ya boy */
    InitializeEvent(0, 11031000, 0);
    SetCharacterTeamType(1031000, 15);
    
    /* Init Maps */
    InitializeEvent(0, 11039000, 0);  // Bloodgulch Arena Init Script
    InitializeEvent(0, 11039100, 0);  // Hangemhigh Arena Init Script
    InitializeEvent(0, 11039200, 0);  // Damnation Arena Init Script
    InitializeEvent(0, 11038000, 0);  // Lockout Arena Init Script
    InitializeEvent(0, 11038100, 0);  // Sanctuary Arena Init Script
    InitializeEvent(0, 11038200, 0);  // Wizard Arena Init Script
    InitializeEvent(0, 11038300, 0);  // HangEmHigh(TDM) Arena Init Script
    InitializeEvent(0, 11038400, 0);  // Sanctuary(CTF) Arena Init Script
    InitializeEvent(0, 11038500, 0);  // Prisoner Arena Init Script
    InitializeEvent(0, 11038600, 0);  // Death Island Arena Init Script
    InitializeEvent(0, 11038700, 0);  // Crossfire Arena Init Script
    InitializeEvent(0, 11038800, 0);  // Ivory Tower Arena Init Script
    InitializeEvent(0, 11038900, 0);  // Chillout Arena Init Script
    
    /* Global A+ Scripts   ( Only added this functionality after msb split so it's not used to full extent really ) */
    InitializeEvent(0, 11039907, 9120, 9125);  // Cost for using consumeable [ Low ]
    InitializeEvent(1, 11039907, 9121, 9126);  // Cost for using consumeable [ High ]
    
    InitializeEvent(0, 11039910, 0); // World fall out safety
});

// Post Init
Event(50, Default, function() {
    
});

/* Ya Boy */
Event(11031000, Default, function() {
    SetNetworkSyncState(Disabled);
    
    IfCharacterHasSpeffect(MAIN, 1031000, 9960, false);
    
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039722, ON); // Uses respawn random flags, picks next miyazaki idle state
    
    
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventFlag, 11039720);  // To :: 1
    SetSpecialAnimations(1031000, 7865, 7866, -1, -1, -1);
    WaitFixedTimeFrames(30);
    // :: 1
    
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventFlag, 11039721);  // To :: 2
    SetSpecialAnimations(1031000, 7867, 7866, -1, -1, -1);
    WaitFixedTimeFrames(30);
    // :: 2
    
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventFlag, 11039722);  // To :: 3
    SetSpecialAnimations(1031000, 7868, 7866, -1, -1, -1);
    WaitFixedTimeFrames(30);
    // :: 3
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Not Supported */
/* Warns player that TTT does not work on this particular map. */
Event(11035000, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfPlayerInoutMap(AND_01, true, 18, 1);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9500);
    SetCharacterTeamType(10000, TeamType.Human);
    DisplayGenericDialog(9012, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
});

/* ========= Templates ========= */

// Template Arena Powerup
// X0_4 - Pickup Interact Region
// X4_4 - Pickup SFX
// X8_4 - Pickup Text Prompt
// X12_4 - Pickup Speffect
// x16_4 - Respawn Delay (frames)
Event(11039900, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4) {
    DeleteMapSFX(X4_4, true);
    SpawnMapSFX(X4_4);
    IfActionButton(AND_01, TargetEntityType.Area, X0_4, 0, -1, 0, X8_4, ReactionType.All, 0);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, X0_4);
    ForceAnimationPlayback(10000, 8130, false, true, false);
    SetSpeffect(10000, X12_4);
    SetSpeffect(10000, 9015);   // Secondary healing effect
    DeleteMapSFX(X4_4, true);
    WaitFixedTimeFrames(X16_4);
    EndUnconditionally(EventEndType.Restart);
});

// Template Arena GiveAmmo
// X0_4 - Trigger Speffect
// X4_4 - Itemlot To Give
Event(11039901, Default, function(X0_4, X4_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(MAIN, 10000, X0_4, true);
    AwardItemsIncludingClients(X4_4);
    ClearSpeffect(10000, X0_4);
    EndUnconditionally(EventEndType.Restart);
});

// Arena 'remove last special arrow' bugfix.
// When firing a special great arrow, you get a speff, when you have this speff, delete the extras from your inven. This is to prevent the arrow from being invis.
Event(11039902, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(MAIN, 10000, 9109, true);
    WaitFixedTimeFrames(10); // Wait a moment
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999);
    ClearSpeffect(10000, 9109);
    EndUnconditionally(EventEndType.Restart);
});

// Template Arena TeleportInteract
// X0_4 - Interact Region
// X4_4 - Target Region
Event(11039905, Default, function(X0_4, X4_4) {
    IfActionButton(AND_01, TargetEntityType.Area, X0_4, 0, -1, 0, 15000150, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, X4_4);
    ForceAnimationPlayback(10000, 7415, false, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// Template Arena TeleportTrigger
// X0_4 - Trigger Region
// X4_4 - Exit Region
Event(11039906, Default, function(X0_4, X4_4) {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, X0_4);
    SetSpeffect(10000, 9001);
    PlayCutsceneAndWarpPlayer(120130, CutscenePlayMode.Unskippable, X4_4, 10, 3, 10000);
    WaitFixedTimeFrames(1);
    ClearSpeffect(10000, 9001);
    EndUnconditionally(EventEndType.Restart);
});

// Template Consumeable Cost
Event(11039907, Default, function(X0_4, X4_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(AND_01, 10000, X0_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, X0_4);
    SetSpeffect(10000, X4_4);
    EndUnconditionally(EventEndType.Restart);
});

/* Flag Desync Fix A Template*/
/* If the flag is dropped (the 'is carried' flag is off) then remove the flag carrying speffs and enable lizard gravity. */
//  X0_4 - Flag Chr
//  X4_4 - Carrying Flag Speff
//  X8_4 - Flag Carry EventFlag ID
Event(11039908, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X8_4);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, X4_4); // For red flag
    SetCharacterGravity(X0_4, Enabled);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Flag Desync Fix B Template*/
/* If the flag is dropped (the 'is carried' flag is off) then remove then reset lizard gravity periodically. */
//  X0_4 - Flag Chr
//  X4_4 - Flag Carry EventFlag ID
Event(11039909, Default, function(X0_4, X4_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X4_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetCharacterGravity(X0_4, Enabled);
    WaitFixedTimeSeconds(3.0);
    
    EndUnconditionally(EventEndType.Restart);
});

/* World fall out safety net */
/* If you fall out of a map (not common but it can happen) we send you to firelink to avoid a potentially buggy death */
Event(11039910, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1030000);
    WarpPlayer(10, 2, 1029100);
});

/* Sanctuary Disable VFX Performance Option */
// Disables waterfalls to help improve framerate
Event(11038162, Default, function() {
    SetNetworkSyncState(Disabled);
    IfActionButton(OR_01, TargetEntityType.Area, 1038115, 180, -1, 1, 10010648, ReactionType.All, 0);
    IfActionButton(OR_01, TargetEntityType.Area, 1038415, 180, -1, 1, 10010648, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, OR_01);
    
    DeleteMapSFX(1038140, false);
    DeleteMapSFX(1038141, false);
    DeleteMapSFX(1038142, false);
    DeleteMapSFX(1038143, false);
    DeleteMapSFX(1038144, false);
    DeleteMapSFX(1038440, false);
    DeleteMapSFX(1038441, false);
    DeleteMapSFX(1038442, false);
    DeleteMapSFX(1038443, false);
    DeleteMapSFX(1038444, false);
});

/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11039000 - Bloodgulch Init Script
// 1039000 - Bloodgulch Staging Area Region
// 1039001 - Bloodgulch Region
// 11039001 - Bloodgulch Give Team Change Items
// 11039002 - Bloodgulch Remove Team Change Items
// 11039003 - Bloodgulch Staging Area Auto-Invade
// 1039002 - Bloodgulch Staging Area Auto-Invade Region
// 11039004 - Bloodgulch Return To Firelink Script
// 1039003 - Bloodgulch Return To Firelink Bonfire
// 11039005 - Bloodgulch Join game Script
// 1039004 - Bloodgulch Join Game Bonfire
// 1039005 - Bloodgulch Join Game Red Warp
// 1039006 - Bloodgulch Join Game Blue Warp
// 11039006 - Bloodgulch Arena No Dead Apply
// 11039007 - Bloodgulch Staging Area Invincibility
// 11039008 - Bloodgulch Offline Kick Out
// 1039007 - Bloodgulch Map Collision
// 11039009 - Bloodgulch give lobby summon sign and fingers
// 11039010 - Bloodgulch enforce red team id
// 1039008 - Bloodgulch Red Return To Lobby Bonfire
// 1039009 - Bloodgulch Blue Return To Lobby Bonfire
// 1039010 - Bloodgulch Return To Lobby Target Region
// 11039011 - Bloodgulch Return to Lobby: Red
// 11039012 - Bloodgulch Return to Lobby: Blue
// 11039013 - Bloodgulch 'On Death' Handler
// 11039014 - Bloodgulch 'On Respawn' Handler
// 1039020 -> 1039024 - Red Team Respawn Points
// 1039025 -> 1039029 - Blue Team Respawn Points
// 1039011 - Bloodgulch Red Flag Character
// 1039012 - Bloodgulch Red Flag Capture Region
// 1039013 - Bloodgulch Game Over Return Target Region
// 1039014 - Bloodgulch Red Flag Stand Target Region
// 11039015 - Bloodgulch Red Flag Pickup Script
// 11039016 - Bloodgulch Red Flag Update Script
// 11039017 - Bloodgulch Red Flag 'Is Picked Up' Flag
// 11039018 - Bloodgulch Red Flag Return Script
// 11039019 - Bloodgulch Red Flag Captured Script
// 11039020 - Bloodgulch Red Lose Flag
// 11039021 - Bloodgulch Red Lose Script
// 1039035 - Bloodgulch Blue Flag Capture Region
// 11039022 - Bloodgulch Red Flag Drop Script
// 11039023 - Bloodgulch Red Flag Reset Script
// 11039024 - Bloodgulch Red Flag Fumble Timer Script
// 11039025 - Bloodgulch Red Flag Fumble Trigger A Script
// 11039026 - Bloodgulch Red Flag Fumble Trigger B Script
// 11039027 - Bloodgulch Red Flag Fumble Animation Script
// 11039028 - Bloodgulch Red Flag Fumble Drop Script
// 11039029 - Bloodgulch Red Flag Fumbling Flag
// 11039030 - Bloodgulch Red Flag Fumbled Flag
// 1039031 - Bloodgulch Blue Flag Character
// 1039034 - Bloodgulch Blue Flag Stand Target Region
// 11039031 - Bloodgulch Blue Flag Pickup Script
// 11039032 - Bloodgulch Blue Flag Update Script
// 11039033 - Bloodgulch Blue Flag 'Is Picked Up' Flag
// 11039043 - Bloodgulch Blue Flag Return Script
// 11039044 - Bloodgulch Blue Flag Captured Script
// 11039045 - Bloodgulch Blue Lose Flag
// 11039046 - Bloodgulch Blue Lose Script
// 11039034 - Bloodgulch Blue Flag Drop Script
// 11039035 - Bloodgulch Blue Flag Reset Script
// 11039036 - Bloodgulch Blue Flag Fumble Timer Script
// 11039037 - Bloodgulch Blue Flag Fumble Trigger A Script
// 11039038 - Bloodgulch Blue Flag Fumble Trigger B Script
// 11039039 - Bloodgulch Blue Flag Fumble Animation Script
// 11039040 - Bloodgulch Blue Flag Fumble Drop Script
// 11039041 - Bloodgulch Blue Flag Fumbling Flag
// 11039042 - Bloodgulch Blue Flag Fumbled Flag
// 11039048 - Bloodgulch Give Hollowing Item
// 11039049 - Bloodgulch Remove Hollowing Item
// 11039050 - Bloodgulch Remove Arena Speff Auto-Invade Fix
// 11039051 - Bloodgulch Red Flag Out Of Bounds Reset
// 11039052 - Bloodgulch Blue Flag Out Of Bounds Reset
// 1039040 - Bloodgulch Red Teleporter Interact Region
// 1039041 - Bloodgulch Red Teleporter Target Region
// 1039042 - Bloodgulch Red Teleporter Trigger Region
// 1039043 - Bloodgulch Red Teleporter Exit Region
// 11039054 - Bloodgulch Respawn Sync'd Speff Remover
// 11039055 - Bloodgulch Red Lizard Notifier
// 11039056 - Bloodgulch Blue Lizard Notifier


/* Bloodgulch Init General */
Event(11039000, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11039017, OFF);  // Reset red flag pickup flag
    SetEventFlag(11039020, OFF);  // Reset red lose flag
    SetEventFlag(11039029, OFF);  // Reset red fumbling flag
    SetEventFlag(11039029, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11039033, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11039045, OFF);  // Reset blue lose flag
    SetEventFlag(11039041, OFF);  // Reset blue fumbling flag
    SetEventFlag(11039042, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039000); // Don't init BG arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039001);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11039001, 0); // Give team change items while in staging area
    InitializeEvent(0, 11039002, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11039003, 0); // Auto-Invade area
    InitializeEvent(0, 11039004, 0); // Return to Firelink
    InitializeEvent(0, 11039005, 0); // Join game
    InitializeEvent(0, 11039006, 0); // Arena No Dead
    InitializeEvent(0, 11039007, 0); // Staging Area Invincibility
    InitializeEvent(0, 11039008, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11039009, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11039010, 0); // Enforce red team id
    InitializeEvent(0, 11039011, 0); // Return to lobby: Red
    InitializeEvent(0, 11039012, 0); // Return to lobby: Blue
    InitializeEvent(0, 11039013, 0); // 'On Death' Handler
    InitializeEvent(0, 11039014, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11039048, 0); // Give Hollowing Item
    InitializeEvent(0, 11039049, 0); // Remove Hollowing Item
    InitializeEvent(0, 11039050, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11039054, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11039015, 0); // Red Flag Pickup
    InitializeEvent(0, 11039016, 0); // Red Flag Update
    InitializeEvent(0, 11039022, 0); // Red Flag Drop
    InitializeEvent(0, 11039018, 0); // Red Flag Return
    InitializeEvent(0, 11039019, 0); // Red Flag Captured
    InitializeEvent(0, 11039023, 0); // Red Flag Reset
    InitializeEvent(0, 11039024, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11039025, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11039026, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11039027, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11039028, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11039021, 0); // Red Lose
    InitializeEvent(0, 11039051, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11039055, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1039011, 9105, 11039017); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1039011, 11039017); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11039031, 0); // Blue Flag Pickup
    InitializeEvent(0, 11039032, 0); // Blue Flag Update
    InitializeEvent(0, 11039034, 0); // Blue Flag Drop
    InitializeEvent(0, 11039043, 0); // Blue Flag Return
    InitializeEvent(0, 11039044, 0); // Blue Flag Captured
    InitializeEvent(0, 11039035, 0); // Blue Flag Reset
    InitializeEvent(0, 11039036, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11039037, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11039038, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11039039, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11039040, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11039046, 0); // Blue Lose
    InitializeEvent(0, 11039052, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11039056, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1039031, 9106, 11039033); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1039031, 11039033); // Blue Flag Desync Fix B Template
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1039040, 1039041); // Red Teleporter Interact
    InitializeEvent(0, 11039906, 1039042, 1039043); // Red Teleporter Trigger
    InitializeEvent(1, 11039905, 1039044, 1039045); // Blue Teleporter Interact
    InitializeEvent(1, 11039906, 1039046, 1039047); // Blue Teleporter Trigger
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1039050, 1039051, 10030160, 9010, 4500); // Powerup 01
    InitializeEvent(1, 11039900, 1039052, 1039053, 10030161, 9021, 600); // Powerup 02
    InitializeEvent(2, 11039900, 1039054, 1039055, 10030161, 9021, 600); // Powerup 03
    InitializeEvent(3, 11039900, 1039056, 1039057, 10030162, 9022, 1350); // Powerup 04
    InitializeEvent(4, 11039900, 1039058, 1039059, 10030162, 9022, 1350); // Powerup 05
    InitializeEvent(5, 11039900, 1039060, 1039061, 10030163, 9023, 1800); // Powerup 06
    InitializeEvent(6, 11039900, 1039062, 1039063, 10030163, 9023, 1800); // Powerup 07
    InitializeEvent(7, 11039900, 1039064, 1039065, 10030173, 9033, 3600); // Powerup 08
    InitializeEvent(8, 11039900, 1039066, 1039067, 10030173, 9033, 3600); // Powerup 09
    InitializeEvent(9, 11039900, 1039068, 1039069, 10030168, 9028, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1039070, 1039071, 10030168, 9028, 3600); // Powerup 11
    InitializeEvent(11, 11039900, 1039072, 1039073, 10030165, 9025, 5400); // Powerup 12
    InitializeEvent(12, 11039900, 1039074, 1039075, 10030170, 9030, 5400); // Powerup 13
    InitializeEvent(13, 11039900, 1039076, 1039077, 10030166, 9026, 5400); // Powerup 14
    InitializeEvent(14, 11039900, 1039078, 1039079, 10030167, 9027, 5400); // Powerup 15
    InitializeEvent(15, 11039900, 1039080, 1039081, 10030161, 9021, 900); // Powerup 16
    InitializeEvent(16, 11039900, 1039082, 1039083, 10030174, 9034, 5400); // Powerup 17
    InitializeEvent(17, 11039900, 1039084, 1039085, 10030164, 9024, 2700); // Powerup 18
    InitializeEvent(18, 11039900, 1039086, 1039087, 10030164, 9024, 2700); // Powerup 19
    InitializeEvent(19, 11039900, 1039088, 1039089, 10030171, 9031, 3600); // Powerup 20
    InitializeEvent(20, 11039900, 1039090, 1039091, 10030172, 9032, 3600); // Powerup 21
    
    /* Set some properties */
    ChangeCharacterEnableState(1039011, Enabled); // Enable red lizard
    SetCharacterInvincibility(1039011, Enabled);  // Make red flag invincible
    ActivateHit(1039011, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1039031, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1039031, Enabled);  // Make blue flag invincible
    ActivateHit(1039031, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031010, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010604, Enabled);  // Lobby entrance message
});

/* Bloodgulch Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11039055, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039011, 1039035);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039011, 1039035);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11039056, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039031, 1039012);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039031, 1039012);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11039001, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039000);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11039002, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039000);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11039048, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11039049, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1039002);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11039050, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Bloodgulch Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11039003, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039002);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Bloodgulch Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11039004, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039003, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1039003);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11039005, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039004, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1039004);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039006, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039005, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Bloodgulch Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11039006, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039000);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039001);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039002);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11039007, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039001);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039000);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Play Area Offline Kickout */
/* If you are in the Bloodgulch play area (the actual bloodgulch map) and you are in singleplayer, kick the player to the staging area. */
Event(11039008, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039001);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Bloodgulch Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11039009, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039000);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11039010, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039000);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039001);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11039011, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039008, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039008);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039010, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11039012, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039009, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039009);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039010, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11039013, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039001);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11039054, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11039014, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039001);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039020, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039021, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039022, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039023, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039024, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039025, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039026, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039027, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039028, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039029, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* Bloodgulch Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11039015, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039017);
    IfActionButton(AND_01, TargetEntityType.Character, 1039011, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1039011);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11039017, ON);
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039016, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039017);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Character, 10000, 91, 1039007);  // Attach flag to player

    SetCharacterGravity(1039011, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039022, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039017);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11039017);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1039011, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039017, OFF);
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11039023, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039017);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039011, 1039035);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11039024, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039017);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11039025, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039029, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039029, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11039026, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039030, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039030, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Bloodgulch Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11039027, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039029);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039011, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11039028, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039030);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1);
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039017, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11039018, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039017);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039011, 1039035);
    IfActionButton(AND_01, TargetEntityType.Character, 1039011, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1039011);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007); // Return flag to it's stand
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* Bloodgulch Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11039019, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039011, 1039012);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039031, 1039012);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11039017, OFF);
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007); // Return flag to it's stand
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039020, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039021, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039020);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039017, OFF);
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007); // Return red flag to it's stand
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039033, OFF);
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039013, 10, 3);
    SetEventFlag(11039020, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11039051, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039011, 1039001);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039017, OFF);
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* Bloodgulch Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11039031, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039033);
    IfActionButton(AND_01, TargetEntityType.Character, 1039031, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1039031);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11039033, ON);
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039032, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039033);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Character, 10000, 91, 1039007);  // Attach flag to player

    SetCharacterGravity(1039031, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039034, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039033);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11039033);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1039031, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039033, OFF);
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11039035, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039033);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039031, 1039012);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11039036, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039033);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11039037, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039041, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039041, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11039038, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039042, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039042, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Bloodgulch Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11039039, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039041);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039031, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11039040, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039042);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1);
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039033, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11039043, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039033);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039031, 1039012);
    IfActionButton(AND_01, TargetEntityType.Character, 1039031, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1039031);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007); // Return flag to it's stand
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11039044, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039011, 1039035);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039031, 1039035);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11039033, OFF);
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007); // Return flag to it's stand
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039045, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039046, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039045);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1039011, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039011, Enabled);
    SetEventFlag(11039017, OFF);
    WarpCharacterAndSetFloor(1039011, TargetEntityType.Area, 1039014, -1, 1039007); // Return red flag to it's stand
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039033, OFF);
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039013, 10, 3);
    SetEventFlag(11039045, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Bloodgulch Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11039052, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039031, 1039001);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039031, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039031, Enabled);
    SetEventFlag(11039033, OFF);
    WarpCharacterAndSetFloor(1039031, TargetEntityType.Area, 1039034, -1, 1039007); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});



/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11039100 - Hangemhigh Init Script
// 1039100 - Hangemhigh Staging Area Region
// 1039101 - Hangemhigh Region
// 11039101 - Hangemhigh Give Team Change Items
// 11039102 - Hangemhigh Remove Team Change Items
// 11039103 - Hangemhigh Staging Area Auto-Invade
// 1039102 - Hangemhigh Staging Area Auto-Invade Region
// 11039104 - Hangemhigh Return To Firelink Script
// 1039103 - Hangemhigh Return To Firelink Bonfire
// 11039105 - Hangemhigh Join game Script
// 1039104 - Hangemhigh Join Game Bonfire
// 1039105 - Hangemhigh Join Game Red Warp
// 1039106 - Hangemhigh Join Game Blue Warp
// 11039106 - Hangemhigh Arena No Dead Apply
// 11039107 - Hangemhigh Staging Area Invincibility
// 11039108 - Hangemhigh Offline Kick Out
// 1039107 - Hangemhigh Map Collision
// 11039109 - Hangemhigh give lobby summon sign and fingers
// 11039110 - Hangemhigh enforce red team id
// 1039108 - Hangemhigh Red Return To Lobby Bonfire
// 1039109 - Hangemhigh Blue Return To Lobby Bonfire
// 1039110 - Hangemhigh Return To Lobby Target Region
// 11039111 - Hangemhigh Return to Lobby: Red
// 11039112 - Hangemhigh Return to Lobby: Blue
// 11039113 - Hangemhigh 'On Death' Handler
// 11039114 - Hangemhigh 'On Respawn' Handler
// 1039120 -> 1039124 - Red Team Respawn Points
// 1039125 -> 1039129 - Blue Team Respawn Points
// 1039111 - Hangemhigh Red Flag Character
// 1039112 - Hangemhigh Red Flag Capture Region
// 1039113 - Hangemhigh Game Over Return Target Region
// 1039114 - Hangemhigh Red Flag Stand Target Region
// 11039115 - Hangemhigh Red Flag Pickup Script
// 11039116 - Hangemhigh Red Flag Update Script
// 11039117 - Hangemhigh Red Flag 'Is Picked Up' Flag
// 11039118 - Hangemhigh Red Flag Return Script
// 11039119 - Hangemhigh Red Flag Captured Script
// 11039120 - Hangemhigh Red Lose Flag
// 11039121 - Hangemhigh Red Lose Script
// 1039135 - Hangemhigh Blue Flag Capture Region
// 11039122 - Hangemhigh Red Flag Drop Script
// 11039123 - Hangemhigh Red Flag Reset Script
// 11039124 - Hangemhigh Red Flag Fumble Timer Script
// 11039125 - Hangemhigh Red Flag Fumble Trigger A Script
// 11039126 - Hangemhigh Red Flag Fumble Trigger B Script
// 11039127 - Hangemhigh Red Flag Fumble Animation Script
// 11039128 - Hangemhigh Red Flag Fumble Drop Script
// 11039129 - Hangemhigh Red Flag Fumbling Flag
// 11039130 - Hangemhigh Red Flag Fumbled Flag
// 1039131 - Hangemhigh Blue Flag Character
// 1039134 - Hangemhigh Blue Flag Stand Target Region
// 11039131 - Hangemhigh Blue Flag Pickup Script
// 11039132 - Hangemhigh Blue Flag Update Script
// 11039133 - Hangemhigh Blue Flag 'Is Picked Up' Flag
// 11039143 - Hangemhigh Blue Flag Return Script
// 11039144 - Hangemhigh Blue Flag Captured Script
// 11039145 - Hangemhigh Blue Lose Flag
// 11039146 - Hangemhigh Blue Lose Script
// 11039134 - Hangemhigh Blue Flag Drop Script
// 11039135 - Hangemhigh Blue Flag Reset Script
// 11039136 - Hangemhigh Blue Flag Fumble Timer Script
// 11039137 - Hangemhigh Blue Flag Fumble Trigger A Script
// 11039138 - Hangemhigh Blue Flag Fumble Trigger B Script
// 11039139 - Hangemhigh Blue Flag Fumble Animation Script
// 11039140 - Hangemhigh Blue Flag Fumble Drop Script
// 11039141 - Hangemhigh Blue Flag Fumbling Flag
// 11039142 - Hangemhigh Blue Flag Fumbled Flag
// 11039148 - Hangemhigh Give Hollowing Item
// 11039149 - Hangemhigh Remove Hollowing Item
// 11039150 - Hangemhigh Remove Arena Speff Auto-Invade Fix
// 11039151 - Hangemhigh Red Flag Out Of Bounds Reset
// 11039152 - Hangemhigh Blue Flag Out Of Bounds Reset
// 11039154 - Hangemhigh Respawn Sync'd Speff Remover
// 11039155 - Hangemhigh Red Lizard Notifier
// 11039156 - Hangemhigh Blue Lizard Notifier


/* Hangemhigh Init General */
Event(11039100, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11039117, OFF);  // Reset red flag pickup flag
    SetEventFlag(11039120, OFF);  // Reset red lose flag
    SetEventFlag(11039129, OFF);  // Reset red fumbling flag
    SetEventFlag(11039129, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11039133, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11039145, OFF);  // Reset blue lose flag
    SetEventFlag(11039141, OFF);  // Reset blue fumbling flag
    SetEventFlag(11039142, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039100); // Don't init HH arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039101);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11039101, 0); // Give team change items while in staging area
    InitializeEvent(0, 11039102, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11039103, 0); // Auto-Invade area
    InitializeEvent(0, 11039104, 0); // Return to Firelink
    InitializeEvent(0, 11039105, 0); // Join game
    InitializeEvent(0, 11039106, 0); // Arena No Dead
    InitializeEvent(0, 11039107, 0); // Staging Area Invincibility
    InitializeEvent(0, 11039108, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11039109, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11039110, 0); // Enforce red team id
    InitializeEvent(0, 11039111, 0); // Return to lobby: Red
    InitializeEvent(0, 11039112, 0); // Return to lobby: Blue
    InitializeEvent(0, 11039113, 0); // 'On Death' Handler
    InitializeEvent(0, 11039114, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11039148, 0); // Give Hollowing Item
    InitializeEvent(0, 11039149, 0); // Remove Hollowing Item
    InitializeEvent(0, 11039150, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11039154, 0); // Synced Respawn Speff Remover
    
    
    InitializeEvent(0, 11039115, 0); // Red Flag Pickup
    InitializeEvent(0, 11039116, 0); // Red Flag Update
    InitializeEvent(0, 11039122, 0); // Red Flag Drop
    InitializeEvent(0, 11039118, 0); // Red Flag Return
    InitializeEvent(0, 11039119, 0); // Red Flag Captured
    InitializeEvent(0, 11039123, 0); // Red Flag Reset
    InitializeEvent(0, 11039124, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11039125, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11039126, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11039127, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11039128, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11039121, 0); // Red Lose
    InitializeEvent(0, 11039151, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11039155, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1039111, 9105, 11039117); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1039111, 11039117); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11039131, 0); // Blue Flag Pickup
    InitializeEvent(0, 11039132, 0); // Blue Flag Update
    InitializeEvent(0, 11039134, 0); // Blue Flag Drop
    InitializeEvent(0, 11039143, 0); // Blue Flag Return
    InitializeEvent(0, 11039144, 0); // Blue Flag Captured
    InitializeEvent(0, 11039135, 0); // Blue Flag Reset
    InitializeEvent(0, 11039136, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11039137, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11039138, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11039139, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11039140, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11039146, 0); // Blue Lose
    InitializeEvent(0, 11039152, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11039156, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1039131, 9106, 11039133); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1039131, 11039133); // Blue Flag Desync Fix B Template
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1039150, 1039151, 10030175, 9035, 4500); // Powerup 00
    InitializeEvent(1, 11039900, 1039152, 1039153, 10030166, 9026, 5400); // Powerup 01
    InitializeEvent(2, 11039900, 1039154, 1039155, 10030165, 9025, 5400); // Powerup 02
    InitializeEvent(3, 11039900, 1039156, 1039157, 10030174, 9034, 4500); // Powerup 03
    InitializeEvent(4, 11039900, 1039158, 1039159, 10030160, 9010, 4500); // Powerup 04
    InitializeEvent(5, 11039900, 1039160, 1039161, 10030167, 9027, 3600); // Powerup 05
    InitializeEvent(6, 11039900, 1039162, 1039163, 10030170, 9030, 3600); // Powerup 06
    InitializeEvent(7, 11039900, 1039164, 1039165, 10030163, 9023, 1350); // Powerup 07
    InitializeEvent(8, 11039900, 1039166, 1039167, 10030163, 9023, 1350); // Powerup 08
    InitializeEvent(9, 11039900, 1039168, 1039169, 10030163, 9023, 1350); // Powerup 09
    InitializeEvent(10, 11039900, 1039170, 1039171, 10030161, 9021, 600); // Powerup 10
    InitializeEvent(11, 11039900, 1039172, 1039173, 10030161, 9021, 600); // Powerup 11
    InitializeEvent(12, 11039900, 1039174, 1039175, 10030162, 9022, 1800); // Powerup 12
    InitializeEvent(13, 11039900, 1039176, 1039177, 10030162, 9022, 1800); // Powerup 13
    InitializeEvent(14, 11039900, 1039178, 1039179, 10030164, 9024, 2700); // Powerup 14
    InitializeEvent(15, 11039900, 1039180, 1039181, 10030171, 9031, 2700); // Powerup 15
    InitializeEvent(16, 11039900, 1039182, 1039183, 10030172, 9032, 2700); // Powerup 16
    InitializeEvent(17, 11039900, 1039184, 1039185, 10030168, 9028, 3600); // Powerup 17
    InitializeEvent(18, 11039900, 1039186, 1039187, 10030173, 9033, 3600); // Powerup 18
    InitializeEvent(19, 11039900, 1039188, 1039189, 10030161, 9021, 900); // Powerup 19
    
    /* Set some properties */
    ChangeCharacterEnableState(1039111, Enabled); // Enable red lizard
    SetCharacterInvincibility(1039111, Enabled);  // Make red flag invincible
    ActivateHit(1039111, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1039131, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1039131, Enabled);  // Make blue flag invincible
    ActivateHit(1039131, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031016, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010607, Enabled);  // Lobby entrance message
});

/* Hangemhigh Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11039155, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039111, 1039135);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039111, 1039135);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11039156, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039031, 1039012);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039031, 1039012);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11039101, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039100);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11039102, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039100);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11039148, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11039149, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1039102);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11039150, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Hangemhigh Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11039103, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039102);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Hangemhigh Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11039104, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039103, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1039103);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11039105, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039104, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1039104);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039106, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039106, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039105, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Hangemhigh Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11039106, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039100);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039101);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039102);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11039107, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039101);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039100);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Play Area Offline Kickout */
/* If you are in the Hangemhigh play area (the actual Hangemhigh map) and you are in singleplayer, kick the player to the staging area. */
Event(11039108, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039101);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Hangemhigh Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11039109, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039100);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11039110, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039100);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039101);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11039111, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039108, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039108);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039110, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11039112, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039109, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039109);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039110, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11039113, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039101);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11039154, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11039114, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039101);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039120, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039121, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039122, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039123, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039124, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039125, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039126, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039127, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039128, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039129, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* Hangemhigh Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11039115, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039117);
    IfActionButton(AND_01, TargetEntityType.Character, 1039111, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1039111);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11039117, ON);
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039116, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039117);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Character, 10000, 91, 1039107);  // Attach flag to player

    SetCharacterGravity(1039111, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039122, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039117);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11039117);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1039111, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039117, OFF);
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11039123, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039117);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039111, 1039135);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11039124, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039117);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11039125, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039129, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039129, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11039126, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039130, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039130, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Hangemhigh Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11039127, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039129);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039111, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11039128, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039130);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1);
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039117, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11039118, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039117);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039111, 1039135);
    IfActionButton(AND_01, TargetEntityType.Character, 1039111, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1039111);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107); // Return flag to it's stand
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* Hangemhigh Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11039119, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039111, 1039112);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039131, 1039112);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11039117, OFF);
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107); // Return flag to it's stand
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039120, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039121, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039120);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039117, OFF);
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107); // Return red flag to it's stand
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039133, OFF);
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039113, 10, 3);
    SetEventFlag(11039120, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11039151, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039111, 1039101);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039117, OFF);
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* Hangemhigh Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11039131, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039133);
    IfActionButton(AND_01, TargetEntityType.Character, 1039131, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1039131);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11039133, ON);
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039132, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039133);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Character, 10000, 91, 1039107);  // Attach flag to player

    SetCharacterGravity(1039131, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11039134, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039133);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11039133);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1039131, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039133, OFF);
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11039135, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039133);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039131, 1039112);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11039136, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039133);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11039137, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039141, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039141, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11039138, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039142, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11039142, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Hangemhigh Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11039139, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039141);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039131, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11039140, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039142);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1);
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039133, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11039143, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039133);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039131, 1039112);
    IfActionButton(AND_01, TargetEntityType.Character, 1039131, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1039131);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107); // Return flag to it's stand
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11039144, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039111, 1039135);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1039131, 1039135);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11039133, OFF);
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107); // Return flag to it's stand
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039145, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039146, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039145);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1039111, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039111, Enabled);
    SetEventFlag(11039117, OFF);
    WarpCharacterAndSetFloor(1039111, TargetEntityType.Area, 1039114, -1, 1039107); // Return red flag to it's stand
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039133, OFF);
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039113, 10, 3);
    SetEventFlag(11039145, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Hangemhigh Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11039152, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1039131, 1039101);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1039131, -1, -1, -1, -1, -1)
    SetCharacterGravity(1039131, Enabled);
    SetEventFlag(11039133, OFF);
    WarpCharacterAndSetFloor(1039131, TargetEntityType.Area, 1039134, -1, 1039107); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11039200 - Damnation Init Script
// 1039200 - Damnation Staging Area Region
// 1039201 - Damnation Region
// 11039201 - Damnation Give Team Change Items
// 11039202 - Damnation Remove Team Change Items
// 11039203 - Damnation Staging Area Auto-Invade
// 1039202 - Damnation Staging Area Auto-Invade Region
// 11039204 - Damnation Return To Firelink Script
// 1039203 - Damnation Return To Firelink Bonfire
// 11039205 - Damnation Join game Script
// 1039204 - Damnation Join Game Bonfire
// 1039205 - Damnation Join Game Red Warp
// 1039206 - Damnation Join Game Blue Warp
// 11039206 - Damnation Arena No Dead Apply
// 11039207 - Damnation Staging Area Invincibility
// 11039208 - Damnation Offline Kick Out
// 1039207 - Damnation Map Collision
// 11039209 - Damnation give lobby summon sign and fingers
// 11039210 - Damnation enforce red team id
// 1039208 - Damnation Red Return To Lobby Bonfire
// 1039209 - Damnation Blue Return To Lobby Bonfire
// 1039210 - Damnation Return To Lobby Target Region
// 11039211 - Damnation Return to Lobby: Red
// 11039212 - Damnation Return to Lobby: Blue
// 11039213 - Damnation 'On Death' Handler
// 11039214 - Damnation 'On Respawn' Handler
// 1039220 -> 1039224 - Red Team Respawn Points
// 1039225 -> 1039229 - Blue Team Respawn Points
// 1039213 - Damnation Game Over Return Target Region
// 11039220 - Damnation Red Lose Flag
// 11039221 - Damnation Red Lose Script
// 11039245 - Damnation Blue Lose Flag
// 11039246 - Damnation Blue Lose Script
// 11039248 - Damnation Give Hollowing Item
// 11039249 - Damnation Remove Hollowing Item
// 11039250 - Damnation Remove Arena Speff Auto-Invade Fix
// 11039254 - Damnation Respawn Sync'd Speff Remover
// 11039252 - Damnation Kill Counter
// 11039223 - Damnation Kill Threshold Messages
// 1039298 - Ladder 00
// 1039299 - Ladder 01
// 11039290 -> 11039293 - Ladder Flags
// 1039297 - Fall Killbox
// 11039294 - Killbox Script
// 11039260 - Damnation Red On Death Kill Count
// 11039261 - Damnation Blue On Death Kill Count


/* Damnation Init General */
Event(11039200, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11039220, OFF);  // Reset red lose flag
    SetEventFlag(11039245, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039200); // Don't init DM arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039201);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11039201, 0); // Give team change items while in staging area
    InitializeEvent(0, 11039202, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11039203, 0); // Auto-Invade area
    InitializeEvent(0, 11039204, 0); // Return to Firelink
    InitializeEvent(0, 11039205, 0); // Join game
    InitializeEvent(0, 11039206, 0); // Arena No Dead
    InitializeEvent(0, 11039207, 0); // Staging Area Invincibility
    InitializeEvent(0, 11039208, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11039209, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11039210, 0); // Enforce red team id
    InitializeEvent(0, 11039211, 0); // Return to lobby: Red
    InitializeEvent(0, 11039212, 0); // Return to lobby: Blue
    InitializeEvent(0, 11039213, 0); // 'On Death' Handler
    InitializeEvent(0, 11039214, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11039248, 0); // Give Hollowing Item
    InitializeEvent(0, 11039249, 0); // Remove Hollowing Item
    InitializeEvent(0, 11039250, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11039254, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11039222, 0); // Red Kill Counter
    InitializeEvent(0, 11039223, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11039221, 0); // Red Lose
    InitializeEvent(0, 11039260, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11039224, 0); // Blue Kill Counter
    InitializeEvent(0, 11039225, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11039246, 0); // Blue Lose
    InitializeEvent(0, 11039261, 0); // Blue On Death Kill Count
    
    /* Ladders */
    RegisterLadder(11039290, 11039291, 1039298);
    RegisterLadder(11039292, 11039293, 1039299);
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1039240, 1039241); // Teleporter A Interact
    InitializeEvent(0, 11039906, 1039242, 1039243); // Teleporter A Trigger
    InitializeEvent(1, 11039905, 1039244, 1039245); // Teleporter B Interact
    InitializeEvent(1, 11039906, 1039246, 1039247); // Teleporter B Trigger
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1039250, 1039251, 10030175, 9035, 4500); // Powerup 00
    InitializeEvent(1, 11039900, 1039252, 1039253, 10030162, 9022, 1800); // Powerup 01
    InitializeEvent(2, 11039900, 1039254, 1039255, 10030163, 9023, 1800); // Powerup 02
    InitializeEvent(3, 11039900, 1039256, 1039257, 10030164, 9024, 2700); // Powerup 03
    InitializeEvent(4, 11039900, 1039258, 1039259, 10030161, 9021, 600); // Powerup 04
    InitializeEvent(5, 11039900, 1039260, 1039261, 10030168, 9028, 3600); // Powerup 05
    InitializeEvent(6, 11039900, 1039262, 1039263, 10030173, 9033, 3600); // Powerup 06
    InitializeEvent(7, 11039900, 1039264, 1039265, 10030170, 9030, 3600); // Powerup 07
    InitializeEvent(8, 11039900, 1039266, 1039267, 10030162, 9022, 1800); // Powerup 08
    InitializeEvent(9, 11039900, 1039268, 1039269, 10030163, 9023, 1800); // Powerup 09
    InitializeEvent(10, 11039900, 1039270, 1039271, 10030161, 9021, 600); // Powerup 10
    InitializeEvent(11, 11039900, 1039272, 1039273, 10030160, 9010, 4500); // Powerup 11
    InitializeEvent(12, 11039900, 1039274, 1039275, 10030167, 9027, 3600); // Powerup 12
    InitializeEvent(13, 11039900, 1039276, 1039277, 10030166, 9026, 4500); // Powerup 13
    InitializeEvent(14, 11039900, 1039278, 1039279, 10030165, 9025, 5400); // Powerup 14
    InitializeEvent(15, 11039900, 1039280, 1039281, 10030174, 9034, 4500); // Powerup 15
    InitializeEvent(16, 11039900, 1039282, 1039283, 10030171, 9031, 3600); // Powerup 16
    InitializeEvent(17, 11039900, 1039284, 1039285, 10030161, 9021, 600); // Powerup 17
    InitializeEvent(18, 11039900, 1039286, 1039287, 10030162, 9022, 1800); // Powerup 18
    InitializeEvent(19, 11039900, 1039288, 1039289, 10030163, 9023, 1800); // Powerup 19
    InitializeEvent(20, 11039900, 1039290, 1039291, 10030172, 9032, 3600); // Powerup 20
    
    /* Killbox */
    InitializeEvent(0, 11039294, 0);          // Killbox if you fall
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031015, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010612, Enabled);  // Lobby entrance message
});



/* Damnation Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11039201, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039200);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11039202, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039200);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11039248, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11039249, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1039202);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11039250, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Damnation Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11039203, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039202);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Damnation Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11039204, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039203, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1039203);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11039205, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1039204, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1039204);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039206, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039206, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039205, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Damnation Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11039206, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039200);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039201);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1039202);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11039207, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1039201);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039200);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Play Area Offline Kickout */
/* If you are in the Damnation play area (the actual Damnation map) and you are in singleplayer, kick the player to the staging area. */
Event(11039208, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039201);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Damnation Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11039209, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039200);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11039210, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039200);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1039201);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11039211, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039208, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039208);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039210, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11039212, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1039209, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1039209);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039210, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11039213, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039201);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Red On Death Kill Counter */
/* Description */
Event(11039260, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Blue On Death Kill Counter */
/* Description */
Event(11039261, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11039254, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11039214, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1039201);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039220, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039221, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039222, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039223, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039224, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039225, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039226, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039227, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039228, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039229, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11039222, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039245);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11039245, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11039223, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11039245); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11039220);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11039224, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11039220);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11039220, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11039225, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11039245); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11039220);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039221, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039220);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039213, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11039220, OFF);  // Reset red lose flag
    SetEventFlag(11039245, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11039246, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11039245);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1039213, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11039220, OFF);  // Reset red lose flag
    SetEventFlag(11039245, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Damnation Killbox */
Event(11039294, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this since we are doing some anims. Also no one will be able to see you fallnig really.
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1039297);
    SetSpeffect(10000, 9000);
    ForceAnimationPlayback(10000, 1670, true, false, true);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038000 - Lockout Init Script
// 1038000 - Lockout Staging Area Region
// 1038001 - Lockout Region
// 11038001 - Lockout Give Team Change Items
// 11038002 - Lockout Remove Team Change Items
// 11038003 - Lockout Staging Area Auto-Invade
// 1038002 - Lockout Staging Area Auto-Invade Region
// 11038004 - Lockout Return To Firelink Script
// 1038003 - Lockout Return To Firelink Bonfire
// 11038005 - Lockout Join game Script
// 1038004 - Lockout Join Game Bonfire
// 1038005 - Lockout Join Game Red Warp
// 1038006 - Lockout Join Game Blue Warp
// 11038006 - Lockout Arena No Dead Apply
// 11038007 - Lockout Staging Area Invincibility
// 11038008 - Lockout Offline Kick Out
// 1038007 - Lockout Map Collision
// 11038009 - Lockout give lobby summon sign and fingers
// 11038010 - Lockout enforce red team id
// 1038008 - Lockout Red Return To Lobby Bonfire
// 1038009 - Lockout Blue Return To Lobby Bonfire
// 1038010 - Lockout Return To Lobby Target Region
// 11038011 - Lockout Return to Lobby: Red
// 11038012 - Lockout Return to Lobby: Blue
// 11038013 - Lockout 'On Death' Handler
// 11038014 - Lockout 'On Respawn' Handler
// 1038020 -> 1038024 - Red Team Respawn Points
// 1038025 -> 1038029 - Blue Team Respawn Points
// 1038013 - Lockout Game Over Return Target Region
// 11038020 - Lockout Red Lose Flag
// 11038021 - Lockout Red Lose Script
// 11038045 - Lockout Blue Lose Flag
// 11038046 - Lockout Blue Lose Script
// 11038048 - Lockout Give Hollowing Item
// 11038049 - Lockout Remove Hollowing Item
// 11038050 - Lockout Remove Arena Speff Auto-Invade Fix
// 11038054 - Lockout Respawn Sync'd Speff Remover
// 11038052 - Lockout Kill Counter
// 11038023 - Lockout Kill Threshold Messages
// 1038098 - Ladder 00
// 1038099 - Ladder 01
// 11038090 -> 11038093 - Ladder Flags
// 1038097 - Fall Killbox
// 11038094 - Killbox Script
// 11038060 - Lockout Red On Death Kill Count
// 11038061 - Lockout Blue On Death Kill Count


/* Lockout Init General */
Event(11038000, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038020, OFF);  // Reset red lose flag
    SetEventFlag(11038045, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038000); // Don't init LK arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038001);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038001, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038002, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038003, 0); // Auto-Invade area
    InitializeEvent(0, 11038004, 0); // Return to Firelink
    InitializeEvent(0, 11038005, 0); // Join game
    InitializeEvent(0, 11038006, 0); // Arena No Dead
    InitializeEvent(0, 11038007, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038008, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038009, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038010, 0); // Enforce red team id
    InitializeEvent(0, 11038011, 0); // Return to lobby: Red
    InitializeEvent(0, 11038012, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038013, 0); // 'On Death' Handler
    InitializeEvent(0, 11038014, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038048, 0); // Give Hollowing Item
    InitializeEvent(0, 11038049, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038050, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038054, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038022, 0); // Red Kill Counter
    InitializeEvent(0, 11038023, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038021, 0); // Red Lose
    InitializeEvent(0, 11038060, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038024, 0); // Blue Kill Counter
    InitializeEvent(0, 11038025, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038046, 0); // Blue Lose
    InitializeEvent(0, 11038061, 0); // Blue On Death Kill Count
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1038040, 1038041); // Teleporter A Interact
    InitializeEvent(0, 11039906, 1038042, 1038043); // Teleporter A Trigger
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038050, 1038051, 10030160, 9010, 4500); // Powerup 01
    InitializeEvent(1, 11039900, 1038052, 1038053, 10030167, 9027, 2700); // Powerup 02
    InitializeEvent(2, 11039900, 1038054, 1038055, 10030161, 9021, 900); // Powerup 03
    InitializeEvent(3, 11039900, 1038056, 1038057, 10030163, 9023, 1350); // Powerup 04
    InitializeEvent(4, 11039900, 1038058, 1038059, 10030168, 9028, 3600); // Powerup 05
    InitializeEvent(5, 11039900, 1038060, 1038061, 10030166, 9026, 4500); // Powerup 06
    InitializeEvent(6, 11039900, 1038062, 1038063, 10030173, 9033, 3600); // Powerup 07
    InitializeEvent(7, 11039900, 1038064, 1038065, 10030175, 9035, 4500); // Powerup 08
    InitializeEvent(8, 11039900, 1038066, 1038067, 10030162, 9022, 1350); // Powerup 09
    InitializeEvent(9, 11039900, 1038068, 1038069, 10030171, 9031, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1038070, 1038071, 10030161, 9021, 900); // Powerup 11
    InitializeEvent(11, 11039900, 1038072, 1038073, 10030163, 9023, 1350); // Powerup 12
    InitializeEvent(12, 11039900, 1038074, 1038075, 10030165, 9025, 4500); // Powerup 13
    InitializeEvent(13, 11039900, 1038076, 1038077, 10030164, 9024, 3600); // Powerup 14
    InitializeEvent(14, 11039900, 1038078, 1038079, 10030162, 9022, 1350); // Powerup 15
    
    /* Killbox */
    InitializeEvent(0, 11038094, 0);          // Killbox if you fall
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031018, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010635, Enabled);  // Lobby entrance message
});



/* Lockout Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038001, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038000);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038002, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038000);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038048, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038049, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038002);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038050, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Lockout Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038003, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038002);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038002);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Lockout Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038004, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038003, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038003);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038005, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038004, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038004);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038006, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038006, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038005, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Lockout Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038006, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038000);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038001);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038002);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038007, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038001);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038000);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Play Area Offline Kickout */
/* If you are in the Lockout play area (the actual Lockout map) and you are in singleplayer, kick the player to the staging area. */
Event(11038008, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038001);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Lockout Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038009, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038000);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038010, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038000);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038001);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038011, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038008, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038008);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038010, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038012, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038009, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038009);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038010, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038013, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038001);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Red On Death Kill Counter */
/* Description */
Event(11038060, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Blue On Death Kill Counter */
/* Description */
Event(11038061, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038054, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038014, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038001);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038020, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038021, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038022, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038023, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038024, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038025, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038026, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038027, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038028, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038029, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038022, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038045);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038045, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038023, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038045); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038020);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038024, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038020);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038020, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038025, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038045); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038020);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038021, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038020);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038013, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038020, OFF);  // Reset red lose flag
    SetEventFlag(11038045, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038046, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038045);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038013, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038020, OFF);  // Reset red lose flag
    SetEventFlag(11038045, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Lockout Killbox */
Event(11038094, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this since we are doing some anims. Also no one will be able to see you fallnig really.
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1038097);
    SetSpeffect(10000, 9000);
    ForceAnimationPlayback(10000, 1670, true, false, true);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038100 - Sanctuary Init Script
// 1038100 - Sanctuary Staging Area Region
// 1038101 - Sanctuary Region
// 11038101 - Sanctuary Give Team Change Items
// 11038102 - Sanctuary Remove Team Change Items
// 11038103 - Sanctuary Staging Area Auto-Invade
// 1038102 - Sanctuary Staging Area Auto-Invade Region
// 11038104 - Sanctuary Return To Firelink Script
// 1038103 - Sanctuary Return To Firelink Bonfire
// 11038105 - Sanctuary Join game Script
// 1038104 - Sanctuary Join Game Bonfire
// 1038105 - Sanctuary Join Game Red Warp
// 1038106 - Sanctuary Join Game Blue Warp
// 11038106 - Sanctuary Arena No Dead Apply
// 11038107 - Sanctuary Staging Area Invincibility
// 11038108 - Sanctuary Offline Kick Out
// 1038107 - Sanctuary Map Collision
// 11038109 - Sanctuary give lobby summon sign and fingers
// 11038110 - Sanctuary enforce red team id
// 1038108 - Sanctuary Red Return To Lobby Bonfire
// 1038109 - Sanctuary Blue Return To Lobby Bonfire
// 1038110 - Sanctuary Return To Lobby Target Region
// 11038111 - Sanctuary Return to Lobby: Red
// 11038112 - Sanctuary Return to Lobby: Blue
// 11038113 - Sanctuary 'On Death' Handler
// 11038114 - Sanctuary 'On Respawn' Handler
// 1038120 -> 1038124 - Red Team Respawn Points
// 1038125 -> 1038129 - Blue Team Respawn Points
// 1038113 - Sanctuary Game Over Return Target Region
// 11038120 - Sanctuary Red Lose Flag
// 11038121 - Sanctuary Red Lose Script
// 11038145 - Sanctuary Blue Lose Flag
// 11038146 - Sanctuary Blue Lose Script
// 11038148 - Sanctuary Give Hollowing Item
// 11038149 - Sanctuary Remove Hollowing Item
// 11038150 - Sanctuary Remove Arena Speff Auto-Invade Fix
// 11038154 - Sanctuary Respawn Sync'd Speff Remover
// 11038152 - Sanctuary Kill Counter
// 11038123 - Sanctuary Kill Threshold Messages
// 1038198 - Ladder 00
// 1038199 - Ladder 01
// 11038190 -> 11038193 - Ladder Flags
// 1038197 - Fall Killbox
// 11038194 - Killbox Script
// 11038160 - Sanctuary Red On Death Kill Count
// 11038161 - Sanctuary Blue On Death Kill Count


/* Sanctuary Init General */
Event(11038100, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038120, OFF);  // Reset red lose flag
    SetEventFlag(11038145, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038100); // Don't init SA arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038101);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038101, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038102, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038103, 0); // Auto-Invade area
    InitializeEvent(0, 11038104, 0); // Return to Firelink
    InitializeEvent(0, 11038105, 0); // Join game
    InitializeEvent(0, 11038106, 0); // Arena No Dead
    InitializeEvent(0, 11038107, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038108, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038109, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038110, 0); // Enforce red team id
    InitializeEvent(0, 11038111, 0); // Return to lobby: Red
    InitializeEvent(0, 11038112, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038113, 0); // 'On Death' Handler
    InitializeEvent(0, 11038114, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038148, 0); // Give Hollowing Item
    InitializeEvent(0, 11038149, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038150, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038154, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038122, 0); // Red Kill Counter
    InitializeEvent(0, 11038123, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038121, 0); // Red Lose
    InitializeEvent(0, 11038160, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038124, 0); // Blue Kill Counter
    InitializeEvent(0, 11038125, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038146, 0); // Blue Lose
    InitializeEvent(0, 11038161, 0); // Blue On Death Kill Count
    
    InitializeEvent(0, 11038162, 0); // Deletes waterfall SFX to help with perfomance
    
    /* Ladders */
    
    /* Teleporters */
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038150, 1038151, 10030175, 9035, 5400); // Powerup 01
    InitializeEvent(1, 11039900, 1038152, 1038153, 10030166, 9026, 3600); // Powerup 02
    InitializeEvent(2, 11039900, 1038154, 1038155, 10030165, 9025, 3600); // Powerup 03
    InitializeEvent(3, 11039900, 1038156, 1038157, 10030162, 9022, 1350); // Powerup 04
    InitializeEvent(4, 11039900, 1038158, 1038159, 10030162, 9022, 1350); // Powerup 05
    InitializeEvent(5, 11039900, 1038160, 1038161, 10030168, 9028, 3600); // Powerup 06
    InitializeEvent(6, 11039900, 1038162, 1038163, 10030168, 9028, 3600); // Powerup 07
    InitializeEvent(7, 11039900, 1038164, 1038165, 10030163, 9023, 1800); // Powerup 08
    InitializeEvent(8, 11039900, 1038166, 1038167, 10030163, 9023, 1800); // Powerup 09
    InitializeEvent(9, 11039900, 1038168, 1038169, 10030171, 9031, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1038170, 1038171, 10030172, 9032, 3600); // Powerup 11
    InitializeEvent(11, 11039900, 1038172, 1038173, 10030164, 9024, 3600); // Powerup 12
    InitializeEvent(12, 11039900, 1038174, 1038175, 10030164, 9024, 3600); // Powerup 13
    InitializeEvent(13, 11039900, 1038176, 1038177, 10030161, 9021, 900); // Powerup 14
    InitializeEvent(14, 11039900, 1038178, 1038179, 10030161, 9021, 900); // Powerup 15
    InitializeEvent(15, 11039900, 1038180, 1038181, 10030167, 9027, 4500); // Powerup 16
    InitializeEvent(16, 11039900, 1038182, 1038183, 10030160, 9010, 4500); // Powerup 17
    InitializeEvent(17, 11039900, 1038184, 1038185, 10030162, 9022, 1350); // Powerup 18
    InitializeEvent(18, 11039900, 1038186, 1038187, 10030162, 9022, 1350); // Powerup 19
    
    /* Killbox */
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031019, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010637, Enabled);  // Lobby entrance message
});


/* Sanctuary Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038101, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038100);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038102, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038100);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038148, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038149, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038102);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038150, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Sanctuary Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038103, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038102);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038102);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038104, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038103, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038103);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038105, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038104, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038104);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038106, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038106, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038105, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038106, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038100);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038101);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038102);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038107, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038101);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038100);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Play Area Offline Kickout */
/* If you are in the Sanctuary play area (the actual Sanctuary map) and you are in singleplayer, kick the player to the staging area. */
Event(11038108, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038101);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Sanctuary Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038109, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038100);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038110, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038100);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038101);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038111, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038108, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038108);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038110, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038112, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038109, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038109);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038110, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038113, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038101);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Red On Death Kill Counter */
/* Description */
Event(11038160, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Blue On Death Kill Counter */
/* Description */
Event(11038161, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038154, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038114, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038101);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038120, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038121, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038122, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038123, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038124, 10, 3); // Warp to respawn point
    SkipUnconditionally(13);
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038125, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038126, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038127, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038128, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038129, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038122, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038145);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038145, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038123, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038145); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038120);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038124, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038120);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038120, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038125, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038145); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038120);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038121, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038120);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038113, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038120, OFF);  // Reset red lose flag
    SetEventFlag(11038145, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038146, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038145);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038113, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038120, OFF);  // Reset red lose flag
    SetEventFlag(11038145, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038200 - Wizard Init Script
// 1038200 - Wizard Staging Area Region
// 1038201 - Wizard Region
// 11038201 - Wizard Give Team Change Items
// 11038202 - Wizard Remove Team Change Items
// 11038203 - Wizard Staging Area Auto-Invade
// 1038202 - Wizard Staging Area Auto-Invade Region
// 11038204 - Wizard Return To Firelink Script
// 1038203 - Wizard Return To Firelink Bonfire
// 11038205 - Wizard Join game Script
// 1038204 - Wizard Join Game Bonfire
// 1038205 - Wizard Join Game Red Warp
// 1038206 - Wizard Join Game Blue Warp
// 11038206 - Wizard Arena No Dead Apply
// 11038207 - Wizard Staging Area Invincibility
// 11038208 - Wizard Offline Kick Out
// 1038207 - Wizard Map Collision
// 11038209 - Wizard give lobby summon sign and fingers
// 11038210 - Wizard enforce red team id
// 1038208 - Wizard Red Return To Lobby Bonfire
// 1038209 - Wizard Blue Return To Lobby Bonfire
// 1038210 - Wizard Return To Lobby Target Region
// 11038211 - Wizard Return to Lobby: Red
// 11038212 - Wizard Return to Lobby: Blue
// 11038213 - Wizard 'On Death' Handler
// 11038214 - Wizard 'On Respawn' Handler
// 1038220 -> 1038224 - Red Team Respawn Points
// 1038225 -> 1038229 - Blue Team Respawn Points
// 1038213 - Wizard Game Over Return Target Region
// 11038220 - Wizard Red Lose Flag
// 11038221 - Wizard Red Lose Script
// 11038245 - Wizard Blue Lose Flag
// 11038246 - Wizard Blue Lose Script
// 11038248 - Wizard Give Hollowing Item
// 11038249 - Wizard Remove Hollowing Item
// 11038250 - Wizard Remove Arena Speff Auto-Invade Fix
// 11038254 - Wizard Respawn Sync'd Speff Remover
// 11038252 - Wizard Kill Counter
// 11038223 - Wizard Kill Threshold Messages
// 1038298 - Ladder 00
// 1038299 - Ladder 01
// 11038290 -> 11038297 - Ladder Flags
// 11038260 - Wizard Red On Death Kill Count
// 11038261 - Wizard Blue On Death Kill Count


/* Wizard Init General */
Event(11038200, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038220, OFF);  // Reset red lose flag
    SetEventFlag(11038245, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038200); // Don't init WZ arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038201);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038201, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038202, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038203, 0); // Auto-Invade area
    InitializeEvent(0, 11038204, 0); // Return to Firelink
    InitializeEvent(0, 11038205, 0); // Join game
    InitializeEvent(0, 11038206, 0); // Arena No Dead
    InitializeEvent(0, 11038207, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038208, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038209, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038210, 0); // Enforce red team id
    InitializeEvent(0, 11038211, 0); // Return to lobby: Red
    InitializeEvent(0, 11038212, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038213, 0); // 'On Death' Handler
    InitializeEvent(0, 11038214, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038248, 0); // Give Hollowing Item
    InitializeEvent(0, 11038249, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038250, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038254, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038222, 0); // Red Kill Counter
    InitializeEvent(0, 11038223, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038221, 0); // Red Lose
    InitializeEvent(0, 11038260, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038224, 0); // Blue Kill Counter
    InitializeEvent(0, 11038225, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038246, 0); // Blue Lose
    InitializeEvent(0, 11038261, 0); // Blue On Death Kill Count
    
    /* Ladders */
    RegisterLadder(11038290, 11038291, 1038296);
    RegisterLadder(11038292, 11038293, 1038297);
    RegisterLadder(11038294, 11038295, 1038298);
    RegisterLadder(11038296, 11038297, 1038299);
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1038240, 1038241); // Wiz Teleporter Interact 01
    InitializeEvent(0, 11039906, 1038242, 1038243); // Wiz Teleporter Trigger 01
    InitializeEvent(1, 11039905, 1038244, 1038245); // Wiz Teleporter Interact 02
    InitializeEvent(1, 11039906, 1038246, 1038247); // Wiz Teleporter Trigger 02
    InitializeEvent(2, 11039905, 1038248, 1038249); // Wiz Teleporter Interact 03
    InitializeEvent(2, 11039906, 1038250, 1038251); // Wiz Teleporter Trigger 03
    InitializeEvent(3, 11039905, 1038252, 1038253); // Wiz Teleporter Interact 04
    InitializeEvent(3, 11039906, 1038254, 1038255); // Wiz Teleporter Trigger 04
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038260, 1038261, 10030175, 9035, 5400); // Powerup 01
    InitializeEvent(1, 11039900, 1038262, 1038263, 10030174, 9034, 5400); // Powerup 02
    InitializeEvent(2, 11039900, 1038264, 1038265, 10030167, 9027, 4500); // Powerup 03
    InitializeEvent(3, 11039900, 1038266, 1038267, 10030166, 9026, 4500); // Powerup 04
    InitializeEvent(4, 11039900, 1038268, 1038269, 10030160, 9010, 4500); // Powerup 05
    InitializeEvent(5, 11039900, 1038270, 1038271, 10030165, 9025, 4500); // Powerup 06
    InitializeEvent(6, 11039900, 1038272, 1038273, 10030164, 9024, 3600); // Powerup 07
    InitializeEvent(7, 11039900, 1038274, 1038275, 10030171, 9031, 3600); // Powerup 08
    InitializeEvent(8, 11039900, 1038276, 1038277, 10030168, 9028, 3600); // Powerup 09
    InitializeEvent(9, 11039900, 1038278, 1038279, 10030172, 9032, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1038280, 1038281, 10030162, 9022, 1350); // Powerup 11
    InitializeEvent(11, 11039900, 1038282, 1038283, 10030162, 9022, 1350); // Powerup 12
    InitializeEvent(12, 11039900, 1038284, 1038285, 10030161, 9021, 900); // Powerup 13
    InitializeEvent(13, 11039900, 1038286, 1038287, 10030161, 9021, 900); // Powerup 14
    InitializeEvent(14, 11039900, 1038288, 1038289, 10030163, 9023, 2700); // Powerup 15
    InitializeEvent(15, 11039900, 1038290, 1038291, 10030163, 9023, 2700); // Powerup 16
    InitializeEvent(16, 11039900, 1038292, 1038293, 10030163, 9023, 2700); // Powerup 17
    InitializeEvent(17, 11039900, 1038294, 1038295, 10030163, 9023, 2700); // Powerup 18
    
    /* Killbox */
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031011, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010639, Enabled);  // Lobby entrance message
});



/* Wizard Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038201, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038200);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038202, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038200);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038248, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038249, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038202);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038250, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Wizard Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038203, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038202);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038202);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Wizard Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038204, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038203, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038203);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038205, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038204, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038204);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038206, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038206, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038205, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Wizard Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038206, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038200);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038201);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038202);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038207, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038201);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038200);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Play Area Offline Kickout */
/* If you are in the Wizard play area (the actual Wizard map) and you are in singleplayer, kick the player to the staging area. */
Event(11038208, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038201);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Wizard Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038209, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038200);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038210, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038200);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038201);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038211, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038208, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038208);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038210, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038212, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038209, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038209);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038210, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038213, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038201);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Red On Death Kill Counter */
/* Description */
Event(11038260, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Blue On Death Kill Counter */
/* Description */
Event(11038261, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038254, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038214, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038201);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038220, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038221, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038222, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038223, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038224, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038225, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038226, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038227, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038228, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038229, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038222, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038245);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038245, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038223, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038245); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038220);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038224, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038220);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038220, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038225, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038245); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038220);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038221, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038220);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038213, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038220, OFF);  // Reset red lose flag
    SetEventFlag(11038245, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Wizard Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038246, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038245);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038213, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038220, OFF);  // Reset red lose flag
    SetEventFlag(11038245, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038300 - HangEmHigh(TDM) Init Script
// 1038300 - HangEmHigh(TDM) Staging Area Region
// 1038301 - HangEmHigh(TDM) Region
// 11038301 - HangEmHigh(TDM) Give Team Change Items
// 11038302 - HangEmHigh(TDM) Remove Team Change Items
// 11038303 - HangEmHigh(TDM) Staging Area Auto-Invade
// 1038302 - HangEmHigh(TDM) Staging Area Auto-Invade Region
// 11038304 - HangEmHigh(TDM) Return To Firelink Script
// 1038303 - HangEmHigh(TDM) Return To Firelink Bonfire
// 11038305 - HangEmHigh(TDM) Join game Script
// 1038304 - HangEmHigh(TDM) Join Game Bonfire
// 1038305 - HangEmHigh(TDM) Join Game Red Warp
// 1038306 - HangEmHigh(TDM) Join Game Blue Warp
// 11038306 - HangEmHigh(TDM) Arena No Dead Apply
// 11038307 - HangEmHigh(TDM) Staging Area Invincibility
// 11038308 - HangEmHigh(TDM) Offline Kick Out
// 1038307 - HangEmHigh(TDM) Map Collision
// 11038309 - HangEmHigh(TDM) give lobby summon sign and fingers
// 11038310 - HangEmHigh(TDM) enforce red team id
// 1038308 - HangEmHigh(TDM) Red Return To Lobby Bonfire
// 1038309 - HangEmHigh(TDM) Blue Return To Lobby Bonfire
// 1038310 - HangEmHigh(TDM) Return To Lobby Target Region
// 11038311 - HangEmHigh(TDM) Return to Lobby: Red
// 11038312 - HangEmHigh(TDM) Return to Lobby: Blue
// 11038313 - HangEmHigh(TDM) 'On Death' Handler
// 11038314 - HangEmHigh(TDM) 'On Respawn' Handler
// 1038320 -> 1038324 - Red Team Respawn Points
// 1038325 -> 1038329 - Blue Team Respawn Points
// 1038313 - HangEmHigh(TDM) Game Over Return Target Region
// 11038320 - HangEmHigh(TDM) Red Lose Flag
// 11038321 - HangEmHigh(TDM) Red Lose Script
// 11038345 - HangEmHigh(TDM) Blue Lose Flag
// 11038346 - HangEmHigh(TDM) Blue Lose Script
// 11038348 - HangEmHigh(TDM) Give Hollowing Item
// 11038349 - HangEmHigh(TDM) Remove Hollowing Item
// 11038350 - HangEmHigh(TDM) Remove Arena Speff Auto-Invade Fix
// 11038354 - HangEmHigh(TDM) Respawn Sync'd Speff Remover
// 11038352 - HangEmHigh(TDM) Kill Counter
// 11038323 - HangEmHigh(TDM) Kill Threshold Messages
// 1038398 - Ladder 00
// 1038399 - Ladder 01
// 11038390 -> 11038393 - Ladder Flags
// 1038397 - Fall Killbox
// 11038394 - Killbox Script
// 11038360 - HangEmHigh(TDM) Red On Death Kill Count
// 11038361 - HangEmHigh(TDM) Blue On Death Kill Count


/* HangEmHigh(TDM) Init General */
Event(11038300, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038320, OFF);  // Reset red lose flag
    SetEventFlag(11038345, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038300); // Don't init HE arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038301);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038301, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038302, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038303, 0); // Auto-Invade area
    InitializeEvent(0, 11038304, 0); // Return to Firelink
    InitializeEvent(0, 11038305, 0); // Join game
    InitializeEvent(0, 11038306, 0); // Arena No Dead
    InitializeEvent(0, 11038307, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038308, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038309, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038310, 0); // Enforce red team id
    InitializeEvent(0, 11038311, 0); // Return to lobby: Red
    InitializeEvent(0, 11038312, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038313, 0); // 'On Death' Handler
    InitializeEvent(0, 11038314, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038348, 0); // Give Hollowing Item
    InitializeEvent(0, 11038349, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038350, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038354, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038322, 0); // Red Kill Counter
    InitializeEvent(0, 11038323, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038321, 0); // Red Lose
    InitializeEvent(0, 11038360, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038324, 0); // Blue Kill Counter
    InitializeEvent(0, 11038325, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038346, 0); // Blue Lose
    InitializeEvent(0, 11038361, 0); // Blue On Death Kill Count
    
    /* Ladders */
    
    /* Teleporters */
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038350, 1038351, 10030175, 9035, 4500); // Powerup 00
    InitializeEvent(1, 11039900, 1038352, 1038353, 10030166, 9026, 5400); // Powerup 01
    InitializeEvent(2, 11039900, 1038354, 1038355, 10030165, 9025, 5400); // Powerup 02
    InitializeEvent(3, 11039900, 1038356, 1038357, 10030174, 9034, 4500); // Powerup 03
    InitializeEvent(4, 11039900, 1038358, 1038359, 10030160, 9010, 4500); // Powerup 04
    InitializeEvent(5, 11039900, 1038360, 1038361, 10030167, 9027, 3600); // Powerup 05
    InitializeEvent(6, 11039900, 1038362, 1038363, 10030170, 9030, 3600); // Powerup 06
    InitializeEvent(7, 11039900, 1038364, 1038365, 10030163, 9023, 1350); // Powerup 07
    InitializeEvent(8, 11039900, 1038366, 1038367, 10030163, 9023, 1350); // Powerup 08
    InitializeEvent(9, 11039900, 1038368, 1038369, 10030163, 9023, 1350); // Powerup 09
    InitializeEvent(10, 11039900, 1038370, 1038371, 10030161, 9021, 600); // Powerup 10
    InitializeEvent(11, 11039900, 1038372, 1038373, 10030161, 9021, 600); // Powerup 11
    InitializeEvent(12, 11039900, 1038374, 1038375, 10030162, 9022, 1800); // Powerup 12
    InitializeEvent(13, 11039900, 1038376, 1038377, 10030162, 9022, 1800); // Powerup 13
    InitializeEvent(14, 11039900, 1038378, 1038379, 10030164, 9024, 2700); // Powerup 14
    InitializeEvent(15, 11039900, 1038380, 1038381, 10030171, 9031, 2700); // Powerup 15
    InitializeEvent(16, 11039900, 1038382, 1038383, 10030172, 9032, 2700); // Powerup 16
    InitializeEvent(17, 11039900, 1038384, 1038385, 10030168, 9028, 3600); // Powerup 17
    InitializeEvent(18, 11039900, 1038386, 1038387, 10030173, 9033, 3600); // Powerup 18
    InitializeEvent(19, 11039900, 1038388, 1038389, 10030161, 9021, 900); // Powerup 19
    
    /* Killbox */
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031017, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010642, Enabled);  // Lobby entrance message
});



/* HangEmHigh(TDM) Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038301, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038300);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038302, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038300);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038348, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038302);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038349, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038302);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038350, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038302);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* HangEmHigh(TDM) Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038303, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038302);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038302);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* HangEmHigh(TDM) Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038304, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038303, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038303);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038305, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038304, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038304);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038306, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038306, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038305, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* HangEmHigh(TDM) Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038306, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038300);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038301);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038302);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038307, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038301);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038300);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Play Area Offline Kickout */
/* If you are in the HangEmHigh(TDM) play area (the actual HangEmHigh(TDM) map) and you are in singleplayer, kick the player to the staging area. */
Event(11038308, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038301);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* HangEmHigh(TDM) Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038309, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038300);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038310, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038300);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038301);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038311, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038308, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038308);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038310, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038312, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038309, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038309);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038310, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038313, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038301);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Red On Death Kill Counter */
/* Description */
Event(11038360, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Blue On Death Kill Counter */
/* Description */
Event(11038361, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038354, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038314, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038301);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038320, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038321, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038322, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038323, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038324, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038325, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038326, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038327, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038328, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038329, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038322, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038345);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038345, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038323, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038345); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038320);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038324, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038320);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038320, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038325, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038345); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038320);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038321, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038320);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038313, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038320, OFF);  // Reset red lose flag
    SetEventFlag(11038345, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* HangEmHigh(TDM) Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038346, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038345);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038313, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038320, OFF);  // Reset red lose flag
    SetEventFlag(11038345, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});


/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11038400 - Sanctuary(CTF) Init Script
// 1038400 - Sanctuary(CTF) Staging Area Region
// 1038401 - Sanctuary(CTF) Region
// 11038401 - Sanctuary(CTF) Give Team Change Items
// 11038402 - Sanctuary(CTF) Remove Team Change Items
// 11038403 - Sanctuary(CTF) Staging Area Auto-Invade
// 1038402 - Sanctuary(CTF) Staging Area Auto-Invade Region
// 11038404 - Sanctuary(CTF) Return To Firelink Script
// 1038403 - Sanctuary(CTF) Return To Firelink Bonfire
// 11038405 - Sanctuary(CTF) Join game Script
// 1038404 - Sanctuary(CTF) Join Game Bonfire
// 1038405 - Sanctuary(CTF) Join Game Red Warp
// 1038406 - Sanctuary(CTF) Join Game Blue Warp
// 11038406 - Sanctuary(CTF) Arena No Dead Apply
// 11038407 - Sanctuary(CTF) Staging Area Invincibility
// 11038408 - Sanctuary(CTF) Offline Kick Out
// 1038407 - Sanctuary(CTF) Map Collision
// 11038409 - Sanctuary(CTF) give lobby summon sign and fingers
// 11038410 - Sanctuary(CTF) enforce red team id
// 1038408 - Sanctuary(CTF) Red Return To Lobby Bonfire
// 1038409 - Sanctuary(CTF) Blue Return To Lobby Bonfire
// 1038410 - Sanctuary(CTF) Return To Lobby Target Region
// 11038411 - Sanctuary(CTF) Return to Lobby: Red
// 11038412 - Sanctuary(CTF) Return to Lobby: Blue
// 11038413 - Sanctuary(CTF) 'On Death' Handler
// 11038414 - Sanctuary(CTF) 'On Respawn' Handler
// 1038420 -> 1038424 - Red Team Respawn Points
// 1038425 -> 1038429 - Blue Team Respawn Points
// 1038411 - Sanctuary(CTF) Red Flag Character
// 1038412 - Sanctuary(CTF) Red Flag Capture Region
// 1038413 - Sanctuary(CTF) Game Over Return Target Region
// 1038414 - Sanctuary(CTF) Red Flag Stand Target Region
// 11038415 - Sanctuary(CTF) Red Flag Pickup Script
// 11038416 - Sanctuary(CTF) Red Flag Update Script
// 11038417 - Sanctuary(CTF) Red Flag 'Is Picked Up' Flag
// 11038418 - Sanctuary(CTF) Red Flag Return Script
// 11038419 - Sanctuary(CTF) Red Flag Captured Script
// 11038420 - Sanctuary(CTF) Red Lose Flag
// 11038421 - Sanctuary(CTF) Red Lose Script
// 1038435 - Sanctuary(CTF) Blue Flag Capture Region
// 11038422 - Sanctuary(CTF) Red Flag Drop Script
// 11038423 - Sanctuary(CTF) Red Flag Reset Script
// 11038424 - Sanctuary(CTF) Red Flag Fumble Timer Script
// 11038425 - Sanctuary(CTF) Red Flag Fumble Trigger A Script
// 11038426 - Sanctuary(CTF) Red Flag Fumble Trigger B Script
// 11038427 - Sanctuary(CTF) Red Flag Fumble Animation Script
// 11038428 - Sanctuary(CTF) Red Flag Fumble Drop Script
// 11038429 - Sanctuary(CTF) Red Flag Fumbling Flag
// 11038430 - Sanctuary(CTF) Red Flag Fumbled Flag
// 1038431 - Sanctuary(CTF) Blue Flag Character
// 1038434 - Sanctuary(CTF) Blue Flag Stand Target Region
// 11038431 - Sanctuary(CTF) Blue Flag Pickup Script
// 11038432 - Sanctuary(CTF) Blue Flag Update Script
// 11038433 - Sanctuary(CTF) Blue Flag 'Is Picked Up' Flag
// 11038443 - Sanctuary(CTF) Blue Flag Return Script
// 11038444 - Sanctuary(CTF) Blue Flag Captured Script
// 11038445 - Sanctuary(CTF) Blue Lose Flag
// 11038446 - Sanctuary(CTF) Blue Lose Script
// 11038434 - Sanctuary(CTF) Blue Flag Drop Script
// 11038435 - Sanctuary(CTF) Blue Flag Reset Script
// 11038436 - Sanctuary(CTF) Blue Flag Fumble Timer Script
// 11038437 - Sanctuary(CTF) Blue Flag Fumble Trigger A Script
// 11038438 - Sanctuary(CTF) Blue Flag Fumble Trigger B Script
// 11038439 - Sanctuary(CTF) Blue Flag Fumble Animation Script
// 11038440 - Sanctuary(CTF) Blue Flag Fumble Drop Script
// 11038441 - Sanctuary(CTF) Blue Flag Fumbling Flag
// 11038442 - Sanctuary(CTF) Blue Flag Fumbled Flag
// 11038448 - Sanctuary(CTF) Give Hollowing Item
// 11038449 - Sanctuary(CTF) Remove Hollowing Item
// 11038450 - Sanctuary(CTF) Remove Arena Speff Auto-Invade Fix
// 11038451 - Sanctuary(CTF) Red Flag Out Of Bounds Reset
// 11038452 - Sanctuary(CTF) Blue Flag Out Of Bounds Reset
// 11038454 - Sanctuary(CTF) Respawn Sync'd Speff Remover
// 11038455 - Sanctuary(CTF) Red Lizard Notifier
// 11038456 - Sanctuary(CTF) Blue Lizard Notifier


/* Sanctuary(CTF) Init General */
Event(11038400, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11038417, OFF);  // Reset red flag pickup flag
    SetEventFlag(11038420, OFF);  // Reset red lose flag
    SetEventFlag(11038429, OFF);  // Reset red fumbling flag
    SetEventFlag(11038429, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11038433, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11038445, OFF);  // Reset blue lose flag
    SetEventFlag(11038441, OFF);  // Reset blue fumbling flag
    SetEventFlag(11038442, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038400); // Don't init SN arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038401);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038401, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038402, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038403, 0); // Auto-Invade area
    InitializeEvent(0, 11038404, 0); // Return to Firelink
    InitializeEvent(0, 11038405, 0); // Join game
    InitializeEvent(0, 11038406, 0); // Arena No Dead
    InitializeEvent(0, 11038407, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038408, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038409, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038410, 0); // Enforce red team id
    InitializeEvent(0, 11038411, 0); // Return to lobby: Red
    InitializeEvent(0, 11038412, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038413, 0); // 'On Death' Handler
    InitializeEvent(0, 11038414, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038448, 0); // Give Hollowing Item
    InitializeEvent(0, 11038449, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038450, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038454, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038415, 0); // Red Flag Pickup
    InitializeEvent(0, 11038416, 0); // Red Flag Update
    InitializeEvent(0, 11038422, 0); // Red Flag Drop
    InitializeEvent(0, 11038418, 0); // Red Flag Return
    InitializeEvent(0, 11038419, 0); // Red Flag Captured
    InitializeEvent(0, 11038423, 0); // Red Flag Reset
    InitializeEvent(0, 11038424, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11038425, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11038426, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11038427, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11038428, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11038421, 0); // Red Lose
    InitializeEvent(0, 11038451, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11038455, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1038411, 9105, 11038417); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1038411, 11038417); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11038431, 0); // Blue Flag Pickup
    InitializeEvent(0, 11038432, 0); // Blue Flag Update
    InitializeEvent(0, 11038434, 0); // Blue Flag Drop
    InitializeEvent(0, 11038443, 0); // Blue Flag Return
    InitializeEvent(0, 11038444, 0); // Blue Flag Captured
    InitializeEvent(0, 11038435, 0); // Blue Flag Reset
    InitializeEvent(0, 11038436, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11038437, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11038438, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11038439, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11038440, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11038446, 0); // Blue Lose
    InitializeEvent(0, 11038452, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11038456, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1038431, 9106, 11038433); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1038431, 11038433); // Blue Flag Desync Fix B Template
    
    InitializeEvent(0, 11038162, 0); // Deletes waterfall SFX to help with perfomance
    
    /* Teleporters */
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038450, 1038451, 10030175, 9035, 5400); // Powerup 01
    InitializeEvent(1, 11039900, 1038452, 1038453, 10030166, 9026, 3600); // Powerup 02
    InitializeEvent(2, 11039900, 1038454, 1038455, 10030165, 9025, 3600); // Powerup 03
    InitializeEvent(3, 11039900, 1038456, 1038457, 10030162, 9022, 1350); // Powerup 04
    InitializeEvent(4, 11039900, 1038458, 1038459, 10030162, 9022, 1350); // Powerup 05
    InitializeEvent(5, 11039900, 1038460, 1038461, 10030168, 9028, 3600); // Powerup 06
    InitializeEvent(6, 11039900, 1038462, 1038463, 10030168, 9028, 3600); // Powerup 07
    InitializeEvent(7, 11039900, 1038464, 1038465, 10030163, 9023, 1800); // Powerup 08
    InitializeEvent(8, 11039900, 1038466, 1038467, 10030163, 9023, 1800); // Powerup 09
    InitializeEvent(9, 11039900, 1038468, 1038469, 10030171, 9031, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1038470, 1038471, 10030172, 9032, 3600); // Powerup 11
    InitializeEvent(11, 11039900, 1038472, 1038473, 10030164, 9024, 3600); // Powerup 12
    InitializeEvent(12, 11039900, 1038474, 1038475, 10030164, 9024, 3600); // Powerup 13
    InitializeEvent(13, 11039900, 1038476, 1038477, 10030161, 9021, 900); // Powerup 14
    InitializeEvent(14, 11039900, 1038478, 1038479, 10030161, 9021, 900); // Powerup 15
    InitializeEvent(15, 11039900, 1038480, 1038481, 10030167, 9027, 4500); // Powerup 16
    InitializeEvent(16, 11039900, 1038482, 1038483, 10030160, 9010, 4500); // Powerup 17
    InitializeEvent(17, 11039900, 1038484, 1038485, 10030162, 9022, 1350); // Powerup 18
    InitializeEvent(18, 11039900, 1038486, 1038487, 10030162, 9022, 1350); // Powerup 19
    
    /* Set some properties */
    ChangeCharacterEnableState(1038411, Enabled); // Enable red lizard
    SetCharacterInvincibility(1038411, Enabled);  // Make red flag invincible
    ActivateHit(1038411, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1038431, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1038431, Enabled);  // Make blue flag invincible
    ActivateHit(1038431, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031020, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010644, Enabled);  // Lobby entrance message
});

/* Sanctuary(CTF) Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038455, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038411, 1038435);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038411, 1038435);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038456, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038431, 1038412);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038431, 1038412);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038401, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038400);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038402, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038400);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038448, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038402);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038449, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038402);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038450, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038402);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Sanctuary(CTF) Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038403, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038402);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038402);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary(CTF) Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038404, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038403, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038403);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038405, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038404, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038404);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038406, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038405, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary(CTF) Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038406, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038400);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038401);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038402);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038407, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038401);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038400);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Play Area Offline Kickout */
/* If you are in the Sanctuary(CTF) play area (the actual Sanctuary(CTF) map) and you are in singleplayer, kick the player to the staging area. */
Event(11038408, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038401);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Sanctuary(CTF) Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038409, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038400);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038410, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038400);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038401);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038411, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038408, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038408);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038410, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038412, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038409, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038409);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038410, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038413, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038401);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038454, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038414, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038401);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038420, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038421, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038422, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038423, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038424, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038425, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038426, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038427, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038428, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038429, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* Sanctuary(CTF) Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11038415, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038417);
    IfActionButton(AND_01, TargetEntityType.Character, 1038411, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038411);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11038417, ON);
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038416, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038417);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Character, 10000, 91, 1038407);  // Attach flag to player

    SetCharacterGravity(1038411, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038422, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038417);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038417);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038411, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038417, OFF);
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038423, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038417);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038411, 1038435);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038424, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038417);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038425, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038429, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038429, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038426, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038430, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038430, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary(CTF) Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038427, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038429);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038411, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038428, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038430);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038417, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11038418, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038417);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038411, 1038435);
    IfActionButton(AND_01, TargetEntityType.Character, 1038411, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038411);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407); // Return flag to it's stand
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary(CTF) Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11038419, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038411, 1038412);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038431, 1038412);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11038417, OFF);
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407); // Return flag to it's stand
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038420, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038421, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038420);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038417, OFF);
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407); // Return red flag to it's stand
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038433, OFF);
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038413, 10, 3);
    SetEventFlag(11038420, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038451, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038411, 1038401);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038417, OFF);
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* Sanctuary(CTF) Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11038431, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038433);
    IfActionButton(AND_01, TargetEntityType.Character, 1038431, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038431);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11038433, ON);
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038432, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038433);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Character, 10000, 91, 1038407);  // Attach flag to player

    SetCharacterGravity(1038431, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038434, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038433);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038433);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038431, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038433, OFF);
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038435, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038433);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038431, 1038412);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038436, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038433);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038437, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038441, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038441, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038438, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038442, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038442, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Sanctuary(CTF) Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038439, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038441);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038431, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038440, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038442);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038433, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11038443, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038433);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038431, 1038412);
    IfActionButton(AND_01, TargetEntityType.Character, 1038431, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038431);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407); // Return flag to it's stand
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11038444, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038411, 1038435);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038431, 1038435);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11038433, OFF);
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407); // Return flag to it's stand
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038445, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038446, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038445);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038411, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038411, Enabled);
    SetEventFlag(11038417, OFF);
    WarpCharacterAndSetFloor(1038411, TargetEntityType.Area, 1038414, -1, 1038407); // Return red flag to it's stand
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038433, OFF);
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038413, 10, 3);
    SetEventFlag(11038445, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Sanctuary(CTF) Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038452, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038431, 1038401);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038431, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038431, Enabled);
    SetEventFlag(11038433, OFF);
    WarpCharacterAndSetFloor(1038431, TargetEntityType.Area, 1038434, -1, 1038407); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11038500 - Prisoner Init Script
// 1038500 - Prisoner Staging Area Region
// 1038501 - Prisoner Region
// 11038501 - Prisoner Give Team Change Items
// 11038502 - Prisoner Remove Team Change Items
// 11038503 - Prisoner Staging Area Auto-Invade
// 1038502 - Prisoner Staging Area Auto-Invade Region
// 11038504 - Prisoner Return To Firelink Script
// 1038503 - Prisoner Return To Firelink Bonfire
// 11038505 - Prisoner Join game Script
// 1038504 - Prisoner Join Game Bonfire
// 1038505 - Prisoner Join Game Red Warp
// 1038506 - Prisoner Join Game Blue Warp
// 11038506 - Prisoner Arena No Dead Apply
// 11038507 - Prisoner Staging Area Invincibility
// 11038508 - Prisoner Offline Kick Out
// 1038507 - Prisoner Map Collision
// 11038509 - Prisoner give lobby summon sign and fingers
// 11038510 - Prisoner enforce red team id
// 1038508 - Prisoner Red Return To Lobby Bonfire
// 1038509 - Prisoner Blue Return To Lobby Bonfire
// 1038510 - Prisoner Return To Lobby Target Region
// 11038511 - Prisoner Return to Lobby: Red
// 11038512 - Prisoner Return to Lobby: Blue
// 11038513 - Prisoner 'On Death' Handler
// 11038514 - Prisoner 'On Respawn' Handler
// 1038520 -> 1038524 - Red Team Respawn Points
// 1038525 -> 1038529 - Blue Team Respawn Points
// 1038511 - Prisoner Red Flag Character
// 1038512 - Prisoner Red Flag Capture Region
// 1038513 - Prisoner Game Over Return Target Region
// 1038514 - Prisoner Red Flag Stand Target Region
// 11038515 - Prisoner Red Flag Pickup Script
// 11038516 - Prisoner Red Flag Update Script
// 11038517 - Prisoner Red Flag 'Is Picked Up' Flag
// 11038518 - Prisoner Red Flag Return Script
// 11038519 - Prisoner Red Flag Captured Script
// 11038520 - Prisoner Red Lose Flag
// 11038521 - Prisoner Red Lose Script
// 1038535 - Prisoner Blue Flag Capture Region
// 11038522 - Prisoner Red Flag Drop Script
// 11038523 - Prisoner Red Flag Reset Script
// 11038524 - Prisoner Red Flag Fumble Timer Script
// 11038525 - Prisoner Red Flag Fumble Trigger A Script
// 11038526 - Prisoner Red Flag Fumble Trigger B Script
// 11038527 - Prisoner Red Flag Fumble Animation Script
// 11038528 - Prisoner Red Flag Fumble Drop Script
// 11038529 - Prisoner Red Flag Fumbling Flag
// 11038530 - Prisoner Red Flag Fumbled Flag
// 1038531 - Prisoner Blue Flag Character
// 1038534 - Prisoner Blue Flag Stand Target Region
// 11038531 - Prisoner Blue Flag Pickup Script
// 11038532 - Prisoner Blue Flag Update Script
// 11038533 - Prisoner Blue Flag 'Is Picked Up' Flag
// 11038543 - Prisoner Blue Flag Return Script
// 11038544 - Prisoner Blue Flag Captured Script
// 11038545 - Prisoner Blue Lose Flag
// 11038546 - Prisoner Blue Lose Script
// 11038534 - Prisoner Blue Flag Drop Script
// 11038535 - Prisoner Blue Flag Reset Script
// 11038536 - Prisoner Blue Flag Fumble Timer Script
// 11038537 - Prisoner Blue Flag Fumble Trigger A Script
// 11038538 - Prisoner Blue Flag Fumble Trigger B Script
// 11038539 - Prisoner Blue Flag Fumble Animation Script
// 11038540 - Prisoner Blue Flag Fumble Drop Script
// 11038541 - Prisoner Blue Flag Fumbling Flag
// 11038542 - Prisoner Blue Flag Fumbled Flag
// 11038548 - Prisoner Give Hollowing Item
// 11038549 - Prisoner Remove Hollowing Item
// 11038550 - Prisoner Remove Arena Speff Auto-Invade Fix
// 11038551 - Prisoner Red Flag Out Of Bounds Reset
// 11038552 - Prisoner Blue Flag Out Of Bounds Reset
// 11038554 - Prisoner Respawn Sync'd Speff Remover
// 11038555 - Prisoner Red Lizard Notifier
// 11038556 - Prisoner Blue Lizard Notifier


/* Prisoner Init General */
Event(11038500, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11038517, OFF);  // Reset red flag pickup flag
    SetEventFlag(11038520, OFF);  // Reset red lose flag
    SetEventFlag(11038529, OFF);  // Reset red fumbling flag
    SetEventFlag(11038529, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11038533, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11038545, OFF);  // Reset blue lose flag
    SetEventFlag(11038541, OFF);  // Reset blue fumbling flag
    SetEventFlag(11038542, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038500); // Don't init SN arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038501);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038501, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038502, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038503, 0); // Auto-Invade area
    InitializeEvent(0, 11038504, 0); // Return to Firelink
    InitializeEvent(0, 11038505, 0); // Join game
    InitializeEvent(0, 11038506, 0); // Arena No Dead
    InitializeEvent(0, 11038507, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038508, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038509, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038510, 0); // Enforce red team id
    InitializeEvent(0, 11038511, 0); // Return to lobby: Red
    InitializeEvent(0, 11038512, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038513, 0); // 'On Death' Handler
    InitializeEvent(0, 11038514, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038548, 0); // Give Hollowing Item
    InitializeEvent(0, 11038549, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038550, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038554, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038515, 0); // Red Flag Pickup
    InitializeEvent(0, 11038516, 0); // Red Flag Update
    InitializeEvent(0, 11038522, 0); // Red Flag Drop
    InitializeEvent(0, 11038518, 0); // Red Flag Return
    InitializeEvent(0, 11038519, 0); // Red Flag Captured
    InitializeEvent(0, 11038523, 0); // Red Flag Reset
    InitializeEvent(0, 11038524, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11038525, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11038526, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11038527, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11038528, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11038521, 0); // Red Lose
    InitializeEvent(0, 11038551, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11038555, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1038511, 9105, 11038517); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1038511, 11038517); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11038531, 0); // Blue Flag Pickup
    InitializeEvent(0, 11038532, 0); // Blue Flag Update
    InitializeEvent(0, 11038534, 0); // Blue Flag Drop
    InitializeEvent(0, 11038543, 0); // Blue Flag Return
    InitializeEvent(0, 11038544, 0); // Blue Flag Captured
    InitializeEvent(0, 11038535, 0); // Blue Flag Reset
    InitializeEvent(0, 11038536, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11038537, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11038538, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11038539, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11038540, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11038546, 0); // Blue Lose
    InitializeEvent(0, 11038552, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11038556, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1038531, 9106, 11038533); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1038531, 11038533); // Blue Flag Desync Fix B Template
    
    /* Ladders */
    RegisterLadder(11033107, 11033108, 1033107);
    RegisterLadder(11033109, 11033110, 1033108);
    RegisterLadder(11033111, 11033112, 1033109);
    RegisterLadder(11033113, 11033114, 1033110);
    
    /* Teleporters */
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038550, 1038551, 10030160, 9010, 4500); // Powerup 01  - Ammo
    InitializeEvent(1, 11039900, 1038552, 1038553, 10030167, 9027, 2700); // Powerup 02  - Rage
    InitializeEvent(2, 11039900, 1038554, 1038555, 10030161, 9021, 900); // Powerup 03   - Heal
    InitializeEvent(3, 11039900, 1038556, 1038557, 10030163, 9023, 1350); // Powerup 04  - Stamina
    InitializeEvent(4, 11039900, 1038558, 1038559, 10030168, 9028, 3600); // Powerup 05  - Karma
    InitializeEvent(5, 11039900, 1038560, 1038561, 10030166, 9026, 4500); // Powerup 06  - Damage
    InitializeEvent(6, 11039900, 1038562, 1038563, 10030173, 9033, 3600); // Powerup 07  - Resonance
    InitializeEvent(7, 11039900, 1038564, 1038565, 10030175, 9035, 4500); // Powerup 08  - Speed
    InitializeEvent(8, 11039900, 1038566, 1038567, 10030162, 9022, 1350); // Powerup 09  - Regen
    InitializeEvent(9, 11039900, 1038568, 1038569, 10030171, 9031, 3600); // Powerup 10  - Flame
    InitializeEvent(10, 11039900, 1038570, 1038571, 10030161, 9021, 900); // Powerup 11  - Heal
    InitializeEvent(11, 11039900, 1038572, 1038573, 10030163, 9023, 1350); // Powerup 12 - Stamina
    InitializeEvent(12, 11039900, 1038574, 1038575, 10030165, 9025, 4500); // Powerup 13 - Defense
    InitializeEvent(13, 11039900, 1038576, 1038577, 10030164, 9024, 3600); // Powerup 14 - Poise
    InitializeEvent(14, 11039900, 1038578, 1038579, 10030162, 9022, 1350); // Powerup 15 - Regen

    
    /* Set some properties */
    ChangeCharacterEnableState(1038511, Enabled); // Enable red lizard
    SetCharacterInvincibility(1038511, Enabled);  // Make red flag invincible
    ActivateHit(1038511, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1038531, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1038531, Enabled);  // Make blue flag invincible
    ActivateHit(1038531, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031021, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010652, Enabled);  // Lobby entrance message
});

/* Prisoner Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038555, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038511, 1038535);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038511, 1038535);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038556, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038531, 1038512);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038531, 1038512);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038501, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038500);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038502, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038500);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038548, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038502);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038549, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038502);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038550, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038502);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Prisoner Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038503, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038502);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038502);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Prisoner Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038504, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038503, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038503);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038505, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038504, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038504);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038506, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038505, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Prisoner Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038506, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038500);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038501);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038502);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038507, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038501);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038500);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Play Area Offline Kickout */
/* If you are in the Prisoner play area (the actual Prisoner map) and you are in singleplayer, kick the player to the staging area. */
Event(11038508, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038501);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Prisoner Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038509, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038500);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038510, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038500);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038501);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038511, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038508, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038508);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038510, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038512, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038509, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038509);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038510, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038513, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038501);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038554, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038514, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038501);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038520, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038521, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038522, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038523, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038524, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038525, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038526, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038527, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038528, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038529, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* Prisoner Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11038515, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038517);
    IfActionButton(AND_01, TargetEntityType.Character, 1038511, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038511);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11038517, ON);
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038516, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038517);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Character, 10000, 91, 1038507);  // Attach flag to player

    SetCharacterGravity(1038511, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038522, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038517);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038517);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038511, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038517, OFF);
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038523, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038517);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038511, 1038535);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038524, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038517);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038525, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038529, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038529, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038526, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038530, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038530, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Prisoner Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038527, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038529);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038511, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038528, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038530);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038517, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11038518, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038517);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038511, 1038535);
    IfActionButton(AND_01, TargetEntityType.Character, 1038511, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038511);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507); // Return flag to it's stand
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* Prisoner Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11038519, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038511, 1038512);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038531, 1038512);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11038517, OFF);
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507); // Return flag to it's stand
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038520, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038521, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038520);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038517, OFF);
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507); // Return red flag to it's stand
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038533, OFF);
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038513, 10, 3);
    SetEventFlag(11038520, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038551, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038511, 1038501);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038517, OFF);
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* Prisoner Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11038531, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038533);
    IfActionButton(AND_01, TargetEntityType.Character, 1038531, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038531);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11038533, ON);
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038532, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038533);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Character, 10000, 91, 1038507);  // Attach flag to player

    SetCharacterGravity(1038531, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038534, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038533);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038533);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038531, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038533, OFF);
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038535, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038533);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038531, 1038512);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038536, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038533);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038537, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038541, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038541, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038538, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038542, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038542, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Prisoner Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038539, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038541);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038531, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038540, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038542);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038533, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11038543, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038533);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038531, 1038512);
    IfActionButton(AND_01, TargetEntityType.Character, 1038531, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038531);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507); // Return flag to it's stand
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11038544, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038511, 1038535);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038531, 1038535);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11038533, OFF);
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507); // Return flag to it's stand
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038545, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038546, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038545);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038511, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038511, Enabled);
    SetEventFlag(11038517, OFF);
    WarpCharacterAndSetFloor(1038511, TargetEntityType.Area, 1038514, -1, 1038507); // Return red flag to it's stand
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038533, OFF);
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038513, 10, 3);
    SetEventFlag(11038545, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Prisoner Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038552, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038531, 1038501);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038531, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038531, Enabled);
    SetEventFlag(11038533, OFF);
    WarpCharacterAndSetFloor(1038531, TargetEntityType.Area, 1038534, -1, 1038507); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11038600 - DeathIsland Init Script
// 1038600 - DeathIsland Staging Area Region
// 1038601 - DeathIsland Region
// 11038601 - DeathIsland Give Team Change Items
// 11038602 - DeathIsland Remove Team Change Items
// 11038603 - DeathIsland Staging Area Auto-Invade
// 1038602 - DeathIsland Staging Area Auto-Invade Region
// 11038604 - DeathIsland Return To Firelink Script
// 1038603 - DeathIsland Return To Firelink Bonfire
// 11038605 - DeathIsland Join game Script
// 1038604 - DeathIsland Join Game Bonfire
// 1038605 - DeathIsland Join Game Red Warp
// 1038606 - DeathIsland Join Game Blue Warp
// 11038606 - DeathIsland Arena No Dead Apply
// 11038607 - DeathIsland Staging Area Invincibility
// 11038608 - DeathIsland Offline Kick Out
// 1038607 - DeathIsland Map Collision
// 11038609 - DeathIsland give lobby summon sign and fingers
// 11038610 - DeathIsland enforce red team id
// 1038608 - DeathIsland Red Return To Lobby Bonfire
// 1038609 - DeathIsland Blue Return To Lobby Bonfire
// 1038610 - DeathIsland Return To Lobby Target Region
// 11038611 - DeathIsland Return to Lobby: Red
// 11038612 - DeathIsland Return to Lobby: Blue
// 11038613 - DeathIsland 'On Death' Handler
// 11038614 - DeathIsland 'On Respawn' Handler
// 1038620 -> 1038624 - Red Team Respawn Points
// 1038625 -> 1038629 - Blue Team Respawn Points
// 1038611 - DeathIsland Red Flag Character
// 1038612 - DeathIsland Red Flag Capture Region
// 1038613 - DeathIsland Game Over Return Target Region
// 1038614 - DeathIsland Red Flag Stand Target Region
// 11038615 - DeathIsland Red Flag Pickup Script
// 11038616 - DeathIsland Red Flag Update Script
// 11038617 - DeathIsland Red Flag 'Is Picked Up' Flag
// 11038618 - DeathIsland Red Flag Return Script
// 11038619 - DeathIsland Red Flag Captured Script
// 11038620 - DeathIsland Red Lose Flag
// 11038621 - DeathIsland Red Lose Script
// 1038635 - DeathIsland Blue Flag Capture Region
// 11038622 - DeathIsland Red Flag Drop Script
// 11038623 - DeathIsland Red Flag Reset Script
// 11038624 - DeathIsland Red Flag Fumble Timer Script
// 11038625 - DeathIsland Red Flag Fumble Trigger A Script
// 11038626 - DeathIsland Red Flag Fumble Trigger B Script
// 11038627 - DeathIsland Red Flag Fumble Animation Script
// 11038628 - DeathIsland Red Flag Fumble Drop Script
// 11038629 - DeathIsland Red Flag Fumbling Flag
// 11038630 - DeathIsland Red Flag Fumbled Flag
// 1038631 - DeathIsland Blue Flag Character
// 1038634 - DeathIsland Blue Flag Stand Target Region
// 11038631 - DeathIsland Blue Flag Pickup Script
// 11038632 - DeathIsland Blue Flag Update Script
// 11038633 - DeathIsland Blue Flag 'Is Picked Up' Flag
// 11038643 - DeathIsland Blue Flag Return Script
// 11038644 - DeathIsland Blue Flag Captured Script
// 11038645 - DeathIsland Blue Lose Flag
// 11038646 - DeathIsland Blue Lose Script
// 11038634 - DeathIsland Blue Flag Drop Script
// 11038635 - DeathIsland Blue Flag Reset Script
// 11038636 - DeathIsland Blue Flag Fumble Timer Script
// 11038637 - DeathIsland Blue Flag Fumble Trigger A Script
// 11038638 - DeathIsland Blue Flag Fumble Trigger B Script
// 11038639 - DeathIsland Blue Flag Fumble Animation Script
// 11038640 - DeathIsland Blue Flag Fumble Drop Script
// 11038641 - DeathIsland Blue Flag Fumbling Flag
// 11038642 - DeathIsland Blue Flag Fumbled Flag
// 11038648 - DeathIsland Give Hollowing Item
// 11038649 - DeathIsland Remove Hollowing Item
// 11038650 - DeathIsland Remove Arena Speff Auto-Invade Fix
// 11038651 - DeathIsland Red Flag Out Of Bounds Reset
// 11038652 - DeathIsland Blue Flag Out Of Bounds Reset
// 11038654 - DeathIsland Respawn Sync'd Speff Remover
// 11038655 - DeathIsland Red Lizard Notifier
// 11038656 - DeathIsland Blue Lizard Notifier


/* DeathIsland Init General */
Event(11038600, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11038617, OFF);  // Reset red flag pickup flag
    SetEventFlag(11038620, OFF);  // Reset red lose flag
    SetEventFlag(11038629, OFF);  // Reset red fumbling flag
    SetEventFlag(11038629, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11038633, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11038645, OFF);  // Reset blue lose flag
    SetEventFlag(11038641, OFF);  // Reset blue fumbling flag
    SetEventFlag(11038642, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038600); // Don't init SN arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038601);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038601, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038602, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038603, 0); // Auto-Invade area
    InitializeEvent(0, 11038604, 0); // Return to Firelink
    InitializeEvent(0, 11038605, 0); // Join game
    InitializeEvent(0, 11038606, 0); // Arena No Dead
    InitializeEvent(0, 11038607, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038608, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038609, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038610, 0); // Enforce red team id
    InitializeEvent(0, 11038611, 0); // Return to lobby: Red
    InitializeEvent(0, 11038612, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038613, 0); // 'On Death' Handler
    InitializeEvent(0, 11038614, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038648, 0); // Give Hollowing Item
    InitializeEvent(0, 11038649, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038650, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038654, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038615, 0); // Red Flag Pickup
    InitializeEvent(0, 11038616, 0); // Red Flag Update
    InitializeEvent(0, 11038622, 0); // Red Flag Drop
    InitializeEvent(0, 11038618, 0); // Red Flag Return
    InitializeEvent(0, 11038619, 0); // Red Flag Captured
    InitializeEvent(0, 11038623, 0); // Red Flag Reset
    InitializeEvent(0, 11038624, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11038625, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11038626, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11038627, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11038628, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11038621, 0); // Red Lose
    InitializeEvent(0, 11038651, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11038655, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1038611, 9105, 11038617); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1038611, 11038617); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11038631, 0); // Blue Flag Pickup
    InitializeEvent(0, 11038632, 0); // Blue Flag Update
    InitializeEvent(0, 11038634, 0); // Blue Flag Drop
    InitializeEvent(0, 11038643, 0); // Blue Flag Return
    InitializeEvent(0, 11038644, 0); // Blue Flag Captured
    InitializeEvent(0, 11038635, 0); // Blue Flag Reset
    InitializeEvent(0, 11038636, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11038637, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11038638, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11038639, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11038640, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11038646, 0); // Blue Lose
    InitializeEvent(0, 11038652, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11038656, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1038631, 9106, 11038633); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1038631, 11038633); // Blue Flag Desync Fix B Template
    
    /* Ladders */
    RegisterLadder(11033000, 11033001, 1033000);
    RegisterLadder(11033002, 11033003, 1033001);
    RegisterLadder(11033004, 11033005, 1033002);
    RegisterLadder(11033006, 11033007, 1033003);
    RegisterLadder(11033008, 11033009, 1033004);
    RegisterLadder(11033010, 11033011, 1033005);
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1033092, 1033093); // DeathIsland Teleporter Interact #1
    InitializeEvent(0, 11039906, 1033094, 1033095); // DeathIsland Teleporter Trigger #1
    InitializeEvent(1, 11039905, 1033096, 1033097); // DeathIsland Teleporter Interact #2
    InitializeEvent(1, 11039906, 1033098, 1033099); // DeathIsland Teleporter Trigger #2
    InitializeEvent(2, 11039905, 1033100, 1033101); // DeathIsland Teleporter Interact #3
    InitializeEvent(2, 11039906, 1033102, 1033103); // DeathIsland Teleporter Trigger #3
    InitializeEvent(3, 11039905, 1033104, 1033105); // DeathIsland Teleporter Interact #4
    InitializeEvent(3, 11039906, 1033106, 1033107); // DeathIsland Teleporter Trigger #4
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038650, 1038651, 10030160, 9010, 4500); // Powerup 01  - Ammo
    InitializeEvent(1, 11039900, 1038652, 1038653, 10030167, 9027, 2700); // Powerup 02  - Rage
    InitializeEvent(2, 11039900, 1038654, 1038655, 10030161, 9021, 900); // Powerup 03   - Heal
    InitializeEvent(3, 11039900, 1038656, 1038657, 10030163, 9023, 1350); // Powerup 04  - Stamina
    InitializeEvent(4, 11039900, 1038658, 1038659, 10030168, 9028, 3600); // Powerup 05  - Karma
    InitializeEvent(5, 11039900, 1038660, 1038661, 10030166, 9026, 4500); // Powerup 06  - Damage
    InitializeEvent(6, 11039900, 1038662, 1038663, 10030174, 9034, 5400); // Powerup 07  - Flip
    InitializeEvent(7, 11039900, 1038664, 1038665, 10030175, 9035, 4500); // Powerup 08  - Speed
    InitializeEvent(8, 11039900, 1038666, 1038667, 10030162, 9022, 1350); // Powerup 09  - Regen
    InitializeEvent(9, 11039900, 1038668, 1038669, 10030171, 9031, 3600); // Powerup 10  - Flame
    InitializeEvent(10, 11039900, 1038670, 1038671, 10030161, 9021, 900); // Powerup 11  - Heal
    InitializeEvent(11, 11039900, 1038672, 1038673, 10030163, 9023, 1350); // Powerup 12 - Stamina
    InitializeEvent(12, 11039900, 1038674, 1038675, 10030165, 9025, 4500); // Powerup 13 - Defense
    InitializeEvent(13, 11039900, 1038676, 1038677, 10030164, 9024, 3600); // Powerup 14 - Poise
    InitializeEvent(14, 11039900, 1038678, 1038679, 10030162, 9022, 1350); // Powerup 15 - Regen
    
    /* Killbox */
    InitializeEvent(0, 11038694, 0);          // Killbox if you drown
    
    /* Set some properties */
    ChangeCharacterEnableState(1038611, Enabled); // Enable red lizard
    SetCharacterInvincibility(1038611, Enabled);  // Make red flag invincible
    ActivateHit(1038611, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1038631, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1038631, Enabled);  // Make blue flag invincible
    ActivateHit(1038631, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031022, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010654, Enabled);  // Lobby entrance message
});

/* DeathIsland Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038655, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038611, 1038635);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038611, 1038635);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038656, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038631, 1038612);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038631, 1038612);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038601, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038600);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038602, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038600);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038648, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038602);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038649, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038602);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038650, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038602);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* DeathIsland Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038603, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038602);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038602);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* DeathIsland Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038604, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038603, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038603);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038605, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038604, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038604);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038606, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038605, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* DeathIsland Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038606, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038600);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038601);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038602);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038607, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038601);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038600);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Play Area Offline Kickout */
/* If you are in the DeathIsland play area (the actual DeathIsland map) and you are in singleplayer, kick the player to the staging area. */
Event(11038608, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038601);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* DeathIsland Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038609, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038600);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038610, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038600);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038601);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038611, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038608, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038608);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038610, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038612, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038609, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038609);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038610, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038613, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038601);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038654, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038614, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038601);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    ClearSpeffect(10000, 9000); // So drown doen't reapply in the 1 frame of moving the player
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038620, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038621, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038622, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038623, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038624, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038625, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038626, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038627, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038628, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038629, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* DeathIsland Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11038615, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038617);
    IfActionButton(AND_01, TargetEntityType.Character, 1038611, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038611);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11038617, ON);
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038616, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038617);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Character, 10000, 91, 1038607);  // Attach flag to player

    SetCharacterGravity(1038611, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038622, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038617);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038617);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038611, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038617, OFF);
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038623, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038617);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038611, 1038635);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038624, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038617);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038625, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038629, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038629, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038626, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038630, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038630, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* DeathIsland Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038627, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038629);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038611, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038628, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038630);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038617, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11038618, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038617);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038611, 1038635);
    IfActionButton(AND_01, TargetEntityType.Character, 1038611, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038611);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607); // Return flag to it's stand
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* DeathIsland Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11038619, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038611, 1038612);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038631, 1038612);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11038617, OFF);
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607); // Return flag to it's stand
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038620, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038621, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038620);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038617, OFF);
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607); // Return red flag to it's stand
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038633, OFF);
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038613, 10, 3);
    SetEventFlag(11038620, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038651, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038611, 1038601);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038617, OFF);
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* DeathIsland Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11038631, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038633);
    IfActionButton(AND_01, TargetEntityType.Character, 1038631, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038631);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11038633, ON);
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038632, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038633);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Character, 10000, 91, 1038607);  // Attach flag to player

    SetCharacterGravity(1038631, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038634, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038633);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038633);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038631, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038633, OFF);
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038635, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038633);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038631, 1038612);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038636, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038633);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038637, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038641, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038641, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038638, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038642, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038642, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* DeathIsland Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038639, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038641);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038631, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038640, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038642);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038633, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11038643, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038633);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038631, 1038612);
    IfActionButton(AND_01, TargetEntityType.Character, 1038631, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038631);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607); // Return flag to it's stand
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11038644, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038611, 1038635);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038631, 1038635);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11038633, OFF);
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607); // Return flag to it's stand
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038645, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038646, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038645);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038611, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038611, Enabled);
    SetEventFlag(11038617, OFF);
    WarpCharacterAndSetFloor(1038611, TargetEntityType.Area, 1038614, -1, 1038607); // Return red flag to it's stand
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038633, OFF);
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038613, 10, 3);
    SetEventFlag(11038645, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038652, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038631, 1038601);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038631, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038631, Enabled);
    SetEventFlag(11038633, OFF);
    WarpCharacterAndSetFloor(1038631, TargetEntityType.Area, 1038634, -1, 1038607); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});

/* DeathIsland Killbox */
Event(11038694, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this since we are doing some anims. Also no one will be able to see you fallnig really.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038697);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Less, 4);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 9000);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* == Special IDs == */
// 11039700 -> 11039707 - Red Flag Reset Timer - 8 Bits
// 11039710 -> 11039717 - Red Flag Fumble Timer - 8 Bits
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039730 -> 11039737 - Blue Flag Reset Timer - 8 Bits
// 11039740 -> 11039747 - Blue Flag Fumble Timer - 8 Bits

/* === ID Dictionary === */
// 11038700 - Crossfire Init Script
// 1038700 - Crossfire Staging Area Region
// 1038701 - Crossfire Region
// 11038701 - Crossfire Give Team Change Items
// 11038702 - Crossfire Remove Team Change Items
// 11038703 - Crossfire Staging Area Auto-Invade
// 1038702 - Crossfire Staging Area Auto-Invade Region
// 11038704 - Crossfire Return To Firelink Script
// 1038703 - Crossfire Return To Firelink Bonfire
// 11038705 - Crossfire Join game Script
// 1038704 - Crossfire Join Game Bonfire
// 1038705 - Crossfire Join Game Red Warp
// 1038706 - Crossfire Join Game Blue Warp
// 11038706 - Crossfire Arena No Dead Apply
// 11038707 - Crossfire Staging Area Invincibility
// 11038708 - Crossfire Offline Kick Out
// 1038707 - Crossfire Map Collision
// 11038709 - Crossfire give lobby summon sign and fingers
// 11038710 - Crossfire enforce red team id
// 1038708 - Crossfire Red Return To Lobby Bonfire
// 1038709 - Crossfire Blue Return To Lobby Bonfire
// 1038710 - Crossfire Return To Lobby Target Region
// 11038711 - Crossfire Return to Lobby: Red
// 11038712 - Crossfire Return to Lobby: Blue
// 11038713 - Crossfire 'On Death' Handler
// 11038714 - Crossfire 'On Respawn' Handler
// 1038720 -> 1038724 - Red Team Respawn Points
// 1038725 -> 1038729 - Blue Team Respawn Points
// 1038711 - Crossfire Red Flag Character
// 1038712 - Crossfire Red Flag Capture Region
// 1038713 - Crossfire Game Over Return Target Region
// 1038714 - Crossfire Red Flag Stand Target Region
// 11038715 - Crossfire Red Flag Pickup Script
// 11038716 - Crossfire Red Flag Update Script
// 11038717 - Crossfire Red Flag 'Is Picked Up' Flag
// 11038718 - Crossfire Red Flag Return Script
// 11038719 - Crossfire Red Flag Captured Script
// 11038720 - Crossfire Red Lose Flag
// 11038721 - Crossfire Red Lose Script
// 1038735 - Crossfire Blue Flag Capture Region
// 11038722 - Crossfire Red Flag Drop Script
// 11038723 - Crossfire Red Flag Reset Script
// 11038724 - Crossfire Red Flag Fumble Timer Script
// 11038725 - Crossfire Red Flag Fumble Trigger A Script
// 11038726 - Crossfire Red Flag Fumble Trigger B Script
// 11038727 - Crossfire Red Flag Fumble Animation Script
// 11038728 - Crossfire Red Flag Fumble Drop Script
// 11038729 - Crossfire Red Flag Fumbling Flag
// 11038730 - Crossfire Red Flag Fumbled Flag
// 1038731 - Crossfire Blue Flag Character
// 1038734 - Crossfire Blue Flag Stand Target Region
// 11038731 - Crossfire Blue Flag Pickup Script
// 11038732 - Crossfire Blue Flag Update Script
// 11038733 - Crossfire Blue Flag 'Is Picked Up' Flag
// 11038743 - Crossfire Blue Flag Return Script
// 11038744 - Crossfire Blue Flag Captured Script
// 11038745 - Crossfire Blue Lose Flag
// 11038746 - Crossfire Blue Lose Script
// 11038734 - Crossfire Blue Flag Drop Script
// 11038735 - Crossfire Blue Flag Reset Script
// 11038736 - Crossfire Blue Flag Fumble Timer Script
// 11038737 - Crossfire Blue Flag Fumble Trigger A Script
// 11038738 - Crossfire Blue Flag Fumble Trigger B Script
// 11038739 - Crossfire Blue Flag Fumble Animation Script
// 11038740 - Crossfire Blue Flag Fumble Drop Script
// 11038741 - Crossfire Blue Flag Fumbling Flag
// 11038742 - Crossfire Blue Flag Fumbled Flag
// 11038748 - Crossfire Give Hollowing Item
// 11038749 - Crossfire Remove Hollowing Item
// 11038750 - Crossfire Remove Arena Speff Auto-Invade Fix
// 11038751 - Crossfire Red Flag Out Of Bounds Reset
// 11038752 - Crossfire Blue Flag Out Of Bounds Reset
// 11038754 - Crossfire Respawn Sync'd Speff Remover
// 11038755 - Crossfire Red Lizard Notifier
// 11038756 - Crossfire Blue Lizard Notifier


/* Crossfire Init General */
Event(11038700, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(13, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    SetEventFlag(11038717, OFF);  // Reset red flag pickup flag
    SetEventFlag(11038720, OFF);  // Reset red lose flag
    SetEventFlag(11038729, OFF);  // Reset red fumbling flag
    SetEventFlag(11038729, OFF);  // Reset red fumbled flag
    ClearEventValue(11039700, 8); // Clear red flag reset timer
    ClearEventValue(11039710, 8); // Clear red flag fumble timer
    SetEventFlag(11038733, OFF);  // Reset blue flag pickup flag
    SetEventFlag(11038745, OFF);  // Reset blue lose flag
    SetEventFlag(11038741, OFF);  // Reset blue fumbling flag
    SetEventFlag(11038742, OFF);  // Reset blue fumbled flag
    ClearEventValue(11039730, 8); // Clear blue flag reset timer
    ClearEventValue(11039740, 8); // Clear blue flag fumble timer
    
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038700); // Don't init SN arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038701);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038701, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038702, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038703, 0); // Auto-Invade area
    InitializeEvent(0, 11038704, 0); // Return to Firelink
    InitializeEvent(0, 11038705, 0); // Join game
    InitializeEvent(0, 11038706, 0); // Arena No Dead
    InitializeEvent(0, 11038707, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038708, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038709, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038710, 0); // Enforce red team id
    InitializeEvent(0, 11038711, 0); // Return to lobby: Red
    InitializeEvent(0, 11038712, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038713, 0); // 'On Death' Handler
    InitializeEvent(0, 11038714, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038748, 0); // Give Hollowing Item
    InitializeEvent(0, 11038749, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038750, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038754, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038715, 0); // Red Flag Pickup
    InitializeEvent(0, 11038716, 0); // Red Flag Update
    InitializeEvent(0, 11038722, 0); // Red Flag Drop
    InitializeEvent(0, 11038718, 0); // Red Flag Return
    InitializeEvent(0, 11038719, 0); // Red Flag Captured
    InitializeEvent(0, 11038723, 0); // Red Flag Reset
    InitializeEvent(0, 11038724, 0); // Red Flag Fumble Timer
    InitializeEvent(0, 11038725, 0); // Red Flag Fumble Trigger A
    InitializeEvent(0, 11038726, 0); // Red Flag Fumble Trigger B
    InitializeEvent(0, 11038727, 0); // Red Flag Fumble Animation
    InitializeEvent(0, 11038728, 0); // Red Flag Fumble Drop
    InitializeEvent(0, 11038721, 0); // Red Lose
    InitializeEvent(0, 11038751, 0); // Red Flag Out Of Bounds Reset
    InitializeEvent(0, 11038755, 0); // Red Lizard Notifier
    InitializeEvent(0, 11039908, 1038711, 9105, 11038717); // Red Flag Desync Fix A Template
    InitializeEvent(0, 11039909, 1038711, 11038717); // Red Flag Desync Fix B Template
    
    InitializeEvent(0, 11038731, 0); // Blue Flag Pickup
    InitializeEvent(0, 11038732, 0); // Blue Flag Update
    InitializeEvent(0, 11038734, 0); // Blue Flag Drop
    InitializeEvent(0, 11038743, 0); // Blue Flag Return
    InitializeEvent(0, 11038744, 0); // Blue Flag Captured
    InitializeEvent(0, 11038735, 0); // Blue Flag Reset
    InitializeEvent(0, 11038736, 0); // Blue Flag Fumble Timer
    InitializeEvent(0, 11038737, 0); // Blue Flag Fumble Trigger A
    InitializeEvent(0, 11038738, 0); // Blue Flag Fumble Trigger B
    InitializeEvent(0, 11038739, 0); // Blue Flag Fumble Animation
    InitializeEvent(0, 11038740, 0); // Blue Flag Fumble Drop
    InitializeEvent(0, 11038746, 0); // Blue Lose
    InitializeEvent(0, 11038752, 0); // Blue Flag Out Of Bounds Reset
    InitializeEvent(0, 11038756, 0); // Blue Lizard Notifier
    InitializeEvent(1, 11039908, 1038731, 9106, 11038733); // Blue Flag Desync Fix A Template
    InitializeEvent(1, 11039909, 1038731, 11038733); // Blue Flag Desync Fix B Template
    
    /* Mantle Points */
    InitializeEvent(0, 11039911, 1033045, 1033040, 7593, 9024);
    InitializeEvent(1, 11039911, 1033046, 1033040, 7593, 9024);
    InitializeEvent(2, 11039911, 1033047, 1033040, 7593, 9024);
    InitializeEvent(3, 11039911, 1033048, 1033040, 7593, 9024);
    InitializeEvent(4, 11039911, 1033049, 1033040, 7594, 9024);
    InitializeEvent(5, 11039911, 1033050, 1033040, 7593, 9024);
    InitializeEvent(6, 11039911, 1033051, 1033040, 7593, 9024);
    InitializeEvent(7, 11039911, 1033052, 1033040, 7593, 9024);
    InitializeEvent(8, 11039911, 1033053, 1033040, 7593, 9024);
    InitializeEvent(9, 11039911, 1033054, 1033040, 7593, 9024);
    InitializeEvent(10, 11039911, 1033055, 1033040, 7593, 9024);
    InitializeEvent(11, 11039911, 1033056, 1033041, 7594, 9024);
    InitializeEvent(12, 11039911, 1033057, 1033041, 7593, 9024);
    InitializeEvent(13, 11039911, 1033058, 1033041, 7593, 9024);
    InitializeEvent(14, 11039911, 1033059, 1033041, 7593, 9024);
    InitializeEvent(15, 11039911, 1033060, 1033042, 7593, 9024);
    InitializeEvent(16, 11039911, 1033061, 1033042, 7593, 9024);
    InitializeEvent(17, 11039911, 1033062, 1033042, 7593, 9024);
    InitializeEvent(18, 11039911, 1033063, 1033042, 7593, 9024);
    InitializeEvent(19, 11039911, 1033064, 1033042, 7594, 9024);
    InitializeEvent(20, 11039911, 1033065, 1033043, 7594, 9024);
    InitializeEvent(21, 11039911, 1033066, 1033043, 7593, 9024);
    InitializeEvent(22, 11039911, 1033067, 1033043, 7593, 9024);
    InitializeEvent(23, 11039911, 1033068, 1033042, 7593, 9024);
    InitializeEvent(24, 11039911, 1033069, 1033040, 7593, 9024);
    InitializeEvent(25, 11039911, 1033070, 1033042, 7593, 9024);
    InitializeEvent(26, 11039911, 1033071, 1033041, 7593, 9024);
    
    /* Ladders */
    RegisterLadder(11033030, 11033031, 1033030);
    RegisterLadder(11033032, 11033033, 1033031);
    RegisterLadder(11033034, 11033035, 1033032);
    RegisterLadder(11033036, 11033037, 1033033);
    RegisterLadder(11033038, 11033039, 1033034);
    RegisterLadder(11033040, 11033041, 1033034);
    RegisterLadder(11033042, 11033043, 1033035);
    RegisterLadder(11033044, 11033045, 1033036);
    RegisterLadder(11033046, 11033047, 1033037);
    
    /* Teleporters */
    
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038750, 1038751, 10030160, 9010, 4500); // Powerup 01
    InitializeEvent(1, 11039900, 1038752, 1038753, 10030167, 9027, 2700); // Powerup 02
    InitializeEvent(2, 11039900, 1038754, 1038755, 10030161, 9021, 900); // Powerup 03
    InitializeEvent(3, 11039900, 1038756, 1038757, 10030163, 9023, 1350); // Powerup 04
    InitializeEvent(4, 11039900, 1038758, 1038759, 10030168, 9028, 3600); // Powerup 05
    InitializeEvent(5, 11039900, 1038760, 1038761, 10030166, 9026, 4500); // Powerup 06
    InitializeEvent(6, 11039900, 1038762, 1038763, 10030173, 9033, 3600); // Powerup 07
    InitializeEvent(7, 11039900, 1038764, 1038765, 10030175, 9035, 4500); // Powerup 08
    InitializeEvent(8, 11039900, 1038766, 1038767, 10030162, 9022, 1350); // Powerup 09
    InitializeEvent(9, 11039900, 1038768, 1038769, 10030171, 9031, 3600); // Powerup 10
    InitializeEvent(10, 11039900, 1038770, 1038771, 10030161, 9021, 900); // Powerup 11
    InitializeEvent(11, 11039900, 1038772, 1038773, 10030163, 9023, 1350); // Powerup 12
    InitializeEvent(12, 11039900, 1038774, 1038775, 10030165, 9025, 4500); // Powerup 13
    InitializeEvent(13, 11039900, 1038776, 1038777, 10030164, 9024, 3600); // Powerup 14
    InitializeEvent(14, 11039900, 1038778, 1038779, 10030162, 9022, 1350); // Powerup 15
    InitializeEvent(15, 11039900, 1038780, 1038781, 10030174, 9034, 5400); // Powerup 16 - Flip
    
    /* Set some properties */
    ChangeCharacterEnableState(1038711, Enabled); // Enable red lizard
    SetCharacterInvincibility(1038711, Enabled);  // Make red flag invincible
    ActivateHit(1038711, Disabled);               // Make red flag no-collide players and avoid all attacks
    ChangeCharacterEnableState(1038731, Enabled); // Enable blue lizard
    SetCharacterInvincibility(1038731, Enabled);  // Make blue flag invincible
    ActivateHit(1038731, Disabled);               // Make blue flag no-collide players and avoid all attacks
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031014, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010656, Enabled);  // Lobby entrance message
});

/* Mantle Template */
// X0_4 Trigger area
// X4_4 Direction
// X8_4 Mantle Animation
Event(11039911, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X0_4);
    IfActionButton(AND_01, TargetEntityType.Object, X4_4, 180, -1, 99999, X12_4, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, X4_4);
    RequestAnimationPlayback(10000, X8_4, false, false);
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Red Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038755, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038711, 1038735);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038711, 1038735);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010632, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Lizard Notifier */
// Dislpay message if lizard stolen
Event(11038756, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038731, 1038712);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038731, 1038712);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(10010633, 0);
    WaitFixedTimeSeconds(15);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038701, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038700);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038702, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038700);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038748, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038702);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038749, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038702);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038750, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038702);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Crossfire Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038703, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038702);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038702);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038704, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038703, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038703);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038705, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038704, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038704);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038706, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038705, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038706, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038700);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038701);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038702);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038707, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038701);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038700);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Play Area Offline Kickout */
/* If you are in the Crossfire play area (the actual Crossfire map) and you are in singleplayer, kick the player to the staging area. */
Event(11038708, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038701);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Crossfire Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038709, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038700);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038710, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038700);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038701);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038711, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038708, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038708);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038710, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038712, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038709, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038709);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038710, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038713, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038701);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038754, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038714, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038701);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038720, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038721, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038722, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038723, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038724, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038725, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038726, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038727, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038728, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038729, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* ====================================================== */
/* ====== Bloogulch ctf red team specific scripts. ====== */
/* ====================================================== */

/* Crossfire Red Flag Pickup */
/* Script to let a blue team player pickup the red flag. */
Event(11038715, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038717);
    IfActionButton(AND_01, TargetEntityType.Character, 1038711, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038711);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9105);                                  // Pickup red flag
    SetEventFlag(11038717, ON);
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038716, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038717);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Character, 10000, 91, 1038707);  // Attach flag to player

    SetCharacterGravity(1038711, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038722, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038717);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038717);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9105, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038711, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9105);
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038717, OFF);
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038723, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038717);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038711, 1038735);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039700, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039700, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039700, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return red flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707);
    ClearEventValue(11039700, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038724, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038717);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039710, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039710, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038725, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038729, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038729, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038726, Default, function() {
    IfEventValue(AND_01, 11039710, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038730, ON);
    
    IfEventValue(AND_01, 11039710, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038730, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Red Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038727, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038729);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038711, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038728, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038730);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038717, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9105, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9105);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Return */
/* Script to let a red team player return red flag to base */
Event(11038718, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038717);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038711, 1038735);
    IfActionButton(AND_01, TargetEntityType.Character, 1038711, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038711);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707); // Return flag to it's stand
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Red Flag Captured */
/* Script to let a red team player return red flag to base */
Event(11038719, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038711, 1038712);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038731, 1038712);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both red flag and blue flag are in the blue capture zone
    ClearSpeffect(10000, 9105);
    SetEventFlag(11038717, OFF);
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707); // Return flag to it's stand
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038720, ON);                              // End game in victory for blue
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038721, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038720);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038717, OFF);
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707); // Return red flag to it's stand
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038733, OFF);
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038713, 10, 3);
    SetEventFlag(11038720, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Red Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038751, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038711, 1038701);         // If red flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038717, OFF);
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707); // Return red flag to it's stand
    ClearSpeffect(10000, 9105);
    EndUnconditionally(EventEndType.Restart);
});


/* ======================================================= */
/* ====== Bloogulch ctf blue team specific scripts. ====== */
/* ======================================================= */


/* Crossfire Blue Flag Pickup */
/* Script to let a Red team player pickup the Blue flag. */
Event(11038731, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Red team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038733);
    IfActionButton(AND_01, TargetEntityType.Character, 1038731, 180, -1, 2.5, 10010613, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                      // If flag is not already picked up
    
    RotateCharacter(10000, 1038731);
    ForceAnimationPlayback(10000, 7522, false, false, false);
    SetSpeffect(10000, 9106);                                  // Pickup Blue flag
    SetEventFlag(11038733, ON);
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Update */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038732, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038733);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);                 // Not dead
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Character, 10000, 91, 1038707);  // Attach flag to player

    SetCharacterGravity(1038731, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Drop */
/* Keep flag attached to player holding it. If they die, drop the flag on the ground. */
Event(11038734, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038733);   // Flag picked up
    IfCharacterHasSpeffect(AND_01, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);                  // Is dead
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11038733);   // Flag picked up
    IfCharacterHasSpeffect(AND_02, 10000, 9106, true);                  // Has flag
    IfCharacterHasSpeffect(AND_02, 10000, 9100, false);                 // Is dead
    IfActionButton(AND_02, TargetEntityType.Character, 1038731, 180, -1, 2.5, 10010615, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    
    ClearSpeffect(10000, 9106);
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038733, OFF);
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1)
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Reset */
/* If the flag is on the ground for 30s, reset it. */
Event(11038735, Default, function() {
    SetNetworkSyncState(Disabled);                                          // Don't sync. The player that is nearest will have the update authority to move it back.
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038733);      // Flag not picked up
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038731, 1038712);  // Flag not at the flag stand
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039730, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039730, 8, 30);                                   // Increment counter 1
    
    IfEventValue(AND_02, 11039730, 8, ComparisonType.Less, 30);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);                   // If the counter reaches 30, return Blue flag to the stand, and clear counter
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707);
    ClearEventValue(11039730, 8);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Fumble Timer */
/* Counts up to 70 while lizard is held by a player. */
Event(11038736, Default, function() {
    WaitFixedTimeSeconds(1);                                                // Run once a second
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);       // Only the host needs to do this
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038733);       // Flag picked up
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    ClearEventValue(11039740, 8);                                           // Clear timer and restart if conditions not met
    EndUnconditionally(EventEndType.Restart);
    
    IncrementEventValue(11039740, 8, 70);                                   // Increment counter 1
    
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Fumble Trigger A */
/* If fumble timer is over 60 we flag an event to start playing the 'about to fumble' animation on the flag. */
Event(11038737, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038741, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 60);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038741, OFF);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Fumble Trigger B */
/* If fumble timer is over 70 we flag an event to tell everyone the flag is dropped now. */
Event(11038738, Default, function() {
    IfEventValue(AND_01, 11039740, 8, ComparisonType.GreaterOrEqual, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038742, ON);
    
    IfEventValue(AND_01, 11039740, 8, ComparisonType.Less, 70);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11038742, OFF);
    EndUnconditionally(EventEndType.Restart);
});


/* Crossfire Blue Flag Fumble Animation */
/* If the fumbling flag is on we play an animation on the flag. */
Event(11038739, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038741);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038731, 7500, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Fumble Drop */
/* If the fumble flag is on we drop the flag. */
Event(11038740, Default, function() {
    WaitFixedTimeSeconds(2.5);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038742);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1);
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038733, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9106, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02); //* might cause bugs. test. */
    DisplayGenericDialog(10010616, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    ClearSpeffect(10000, 9106);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Return */
/* Script to let a Blue team player return Blue flag to base */
Event(11038743, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_01, PASS, OR_01);                       // If on Blue team
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038733);                                        
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038731, 1038712);
    IfActionButton(AND_01, TargetEntityType.Character, 1038731, 180, -1, 2.5, 10010614, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);                       // If flag is not already picked up, and it's not on the stand
    
    RotateCharacter(10000, 1038731);
    ForceAnimationPlayback(10000, 7522, false, false, false);         
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707); // Return flag to it's stand
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Captured */
/* Script to let a Blue team player return Blue flag to base */
Event(11038744, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038711, 1038735);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1038731, 1038735);
    IfConditionGroup(MAIN, PASS, AND_01);                    // Both Blue flag and Red flag are in the Red capture zone
    ClearSpeffect(10000, 9106);
    SetEventFlag(11038733, OFF);
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707); // Return flag to it's stand
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038745, ON);                              // End game in victory for Red
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038746, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038745);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Force flag drop and reset */
    SetSpecialAnimations(1038711, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038711, Enabled);
    SetEventFlag(11038717, OFF);
    WarpCharacterAndSetFloor(1038711, TargetEntityType.Area, 1038714, -1, 1038707); // Return red flag to it's stand
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038733, OFF);
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707); // Return blue flag to it's stand
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038713, 10, 3);
    SetEventFlag(11038745, OFF);
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Crossfire Blue Flag Out Of Bounds Reset */
/* If the flag falls out of the map area, reset it fully. */
Event(11038752, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 1038731, 1038701);         // If blue flag is outside of the map play area
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpecialAnimations(1038731, -1, -1, -1, -1, -1)
    SetCharacterGravity(1038731, Enabled);
    SetEventFlag(11038733, OFF);
    WarpCharacterAndSetFloor(1038731, TargetEntityType.Area, 1038734, -1, 1038707); // Return blue flag to it's stand
    ClearSpeffect(10000, 9106);
    EndUnconditionally(EventEndType.Restart);
});


/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038800 - IvoryTower Init Script
// 1038800 - IvoryTower Staging Area Region
// 1038801 - IvoryTower Region
// 11038801 - IvoryTower Give Team Change Items
// 11038802 - IvoryTower Remove Team Change Items
// 11038803 - IvoryTower Staging Area Auto-Invade
// 1038802 - IvoryTower Staging Area Auto-Invade Region
// 11038804 - IvoryTower Return To Firelink Script
// 1038803 - IvoryTower Return To Firelink Bonfire
// 11038805 - IvoryTower Join game Script
// 1038804 - IvoryTower Join Game Bonfire
// 1038805 - IvoryTower Join Game Red Warp
// 1038806 - IvoryTower Join Game Blue Warp
// 11038806 - IvoryTower Arena No Dead Apply
// 11038807 - IvoryTower Staging Area Invincibility
// 11038808 - IvoryTower Offline Kick Out
// 1038807 - IvoryTower Map Collision
// 11038809 - IvoryTower give lobby summon sign and fingers
// 11038810 - IvoryTower enforce red team id
// 1038808 - IvoryTower Red Return To Lobby Bonfire
// 1038809 - IvoryTower Blue Return To Lobby Bonfire
// 1038810 - IvoryTower Return To Lobby Target Region
// 11038811 - IvoryTower Return to Lobby: Red
// 11038812 - IvoryTower Return to Lobby: Blue
// 11038813 - IvoryTower 'On Death' Handler
// 11038814 - IvoryTower 'On Respawn' Handler
// 1038820 -> 1038824 - Red Team Respawn Points
// 1038825 -> 1038829 - Blue Team Respawn Points
// 1038813 - IvoryTower Game Over Return Target Region
// 11038820 - IvoryTower Red Lose Flag
// 11038821 - IvoryTower Red Lose Script
// 11038845 - IvoryTower Blue Lose Flag
// 11038846 - IvoryTower Blue Lose Script
// 11038848 - IvoryTower Give Hollowing Item
// 11038849 - IvoryTower Remove Hollowing Item
// 11038850 - IvoryTower Remove Arena Speff Auto-Invade Fix
// 11038854 - IvoryTower Respawn Sync'd Speff Remover
// 11038852 - IvoryTower Kill Counter
// 11038823 - IvoryTower Kill Threshold Messages
// 1038898 - Ladder 00
// 1038899 - Ladder 01
// 11038890 -> 11038893 - Ladder Flags
// 11038860 - IvoryTower Red On Death Kill Count
// 11038861 - IvoryTower Blue On Death Kill Count


/* IvoryTower Init General */
Event(11038800, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038820, OFF);  // Reset red lose flag
    SetEventFlag(11038845, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038800); // Don't init LK arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038801);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038801, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038802, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038803, 0); // Auto-Invade area
    InitializeEvent(0, 11038804, 0); // Return to Firelink
    InitializeEvent(0, 11038805, 0); // Join game
    InitializeEvent(0, 11038806, 0); // Arena No Dead
    InitializeEvent(0, 11038807, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038808, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038809, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038810, 0); // Enforce red team id
    InitializeEvent(0, 11038811, 0); // Return to lobby: Red
    InitializeEvent(0, 11038812, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038813, 0); // 'On Death' Handler
    InitializeEvent(0, 11038814, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038848, 0); // Give Hollowing Item
    InitializeEvent(0, 11038849, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038850, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038854, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038822, 0); // Red Kill Counter
    InitializeEvent(0, 11038823, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038821, 0); // Red Lose
    InitializeEvent(0, 11038860, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038824, 0); // Blue Kill Counter
    InitializeEvent(0, 11038825, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038846, 0); // Blue Lose
    InitializeEvent(0, 11038861, 0); // Blue On Death Kill Count
    
    InitializeEvent(0, 11038871, 0); // Lol
    InitializeEvent(0, 11038872, 0); // Lol
    
    /* Mantle Points */
    InitializeEvent(0, 11039911, 1033125, 1033123, 7594, 9024);
    InitializeEvent(1, 11039911, 1033126, 1033122, 7594, 9024);
    InitializeEvent(2, 11039911, 1033127, 1033121, 7595, 9600);
    InitializeEvent(3, 11039911, 1033128, 1033121, 7595, 9600);
    InitializeEvent(4, 11039911, 1033129, 1033121, 7595, 9600);
    InitializeEvent(5, 11039911, 1033130, 1033121, 7595, 9600);
    InitializeEvent(6, 11039911, 1033131, 1033121, 7595, 9600);
    InitializeEvent(7, 11039911, 1033132, 1033138, 7595, 9600);
    InitializeEvent(8, 11039911, 1033133, 1033138, 7595, 9600);
    InitializeEvent(9, 11039911, 1033134, 1033121, 7595, 9600);
    InitializeEvent(10, 11039911, 1033135, 1033137, 7595, 9600);
    InitializeEvent(11, 11039911, 1033136, 1033137, 7595, 9600);
    InitializeEvent(12, 11039911, 1033139, 1033123, 7595, 9600);
    InitializeEvent(13, 11039911, 1033140, 1033122, 7595, 9600);
    
    /* Ladders */
    RegisterLadder(11033020, 11033021, 1033020);
    RegisterLadder(11033022, 11033023, 1033021);
    RegisterLadder(11033024, 11033025, 1033022);
    RegisterLadder(11033026, 11033027, 1033023);
    RegisterLadder(11033028, 11033029, 1033024);
    
    /* Teleporters */
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038850, 1038851, 10030160, 9010, 4500); // Powerup 01  - Ammo
    InitializeEvent(1, 11039900, 1038852, 1038853, 10030167, 9027, 2700); // Powerup 02  - Rage
    InitializeEvent(2, 11039900, 1038854, 1038855, 10030161, 9021, 900); // Powerup 03   - Heal
    InitializeEvent(3, 11039900, 1038856, 1038857, 10030163, 9023, 1350); // Powerup 04  - Stamina
    InitializeEvent(4, 11039900, 1038858, 1038859, 10030168, 9028, 3600); // Powerup 05  - Karma
    InitializeEvent(5, 11039900, 1038860, 1038861, 10030166, 9026, 4500); // Powerup 06  - Damage
    InitializeEvent(6, 11039900, 1038862, 1038863, 10030173, 9033, 3600); // Powerup 07  - Resonance
    InitializeEvent(7, 11039900, 1038864, 1038865, 10030175, 9035, 4500); // Powerup 08  - Speed
    InitializeEvent(8, 11039900, 1038866, 1038867, 10030162, 9022, 1350); // Powerup 09  - Regen
    InitializeEvent(9, 11039900, 1038868, 1038869, 10030171, 9031, 3600); // Powerup 10  - Flame
    InitializeEvent(10, 11039900, 1038870, 1038871, 10030161, 9021, 900); // Powerup 11  - Heal
    InitializeEvent(11, 11039900, 1038872, 1038873, 10030163, 9023, 1350); // Powerup 12 - Stamina
    InitializeEvent(12, 11039900, 1038874, 1038875, 10030165, 9025, 4500); // Powerup 13 - Defense
    InitializeEvent(13, 11039900, 1038876, 1038877, 10030164, 9024, 3600); // Powerup 14 - Poise
    InitializeEvent(14, 11039900, 1038878, 1038879, 10030162, 9022, 1350); // Powerup 15 - Regen
    InitializeEvent(15, 11039900, 1038880, 1038881, 10030174, 9034, 5400); // Powerup 16 - Flip
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031013, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010662, Enabled);  // Lobby entrance message
});

/* IvoryTower Waterfall auto toggle 1 */
Event(11038871, Default, function() {
    SetNetworkSyncState(Disabled);
    DeleteMapSFX(1038445, false);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038446);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038447);
    IfConditionGroup(MAIN, PASS, OR_01);
    SpawnMapSFX(1038445);
    IfInoutsideArea(OR_02, InsideOutsideState.Inside, 10000, 1038446);
    IfInoutsideArea(OR_02, InsideOutsideState.Inside, 10000, 1038447);
    IfConditionGroup(MAIN, FAIL, OR_02);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Waterfall auto toggle 2 */
Event(11038872, Default, function() {
    SetNetworkSyncState(Disabled);
    DeleteMapSFX(1038449, false);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1038448);
    SpawnMapSFX(1038449);
    IfInoutsideArea(MAIN, InsideOutsideState.Outside, 10000, 1038448);
    EndUnconditionally(EventEndType.Restart);
});



/* IvoryTower Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038801, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038800);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038802, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038800);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038848, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038802);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038849, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038802);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038850, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038802);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* IvoryTower Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038803, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038802);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038802);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* IvoryTower Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038804, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038803, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038803);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038805, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038804, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038804);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038806, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038806, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038805, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* IvoryTower Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038806, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038800);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038801);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038802);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038807, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038801);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038800);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Play Area Offline Kickout */
/* If you are in the IvoryTower play area (the actual IvoryTower map) and you are in singleplayer, kick the player to the staging area. */
Event(11038808, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038801);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* IvoryTower Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038809, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038800);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038810, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038800);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038801);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038811, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038808, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038808);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038810, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038812, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038809, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038809);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038810, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038813, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038801);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Red On Death Kill Counter */
/* Description */
Event(11038860, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Blue On Death Kill Counter */
/* Description */
Event(11038861, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038854, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038814, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038801);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038820, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038821, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038822, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038823, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038824, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038825, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038826, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038827, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038828, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038829, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038822, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038845);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038845, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038823, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038845); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038820);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038824, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038820);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038820, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038825, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038845); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038820);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038821, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038820);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038813, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038820, OFF);  // Reset red lose flag
    SetEventFlag(11038845, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* IvoryTower Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038846, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038845);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038813, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038820, OFF);  // Reset red lose flag
    SetEventFlag(11038845, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});


/* == Special IDs == */
// 11039720 -> 11039724 - Randomize Respawn Flags - 5 Bits
// 11039750 -> 11039757 - Red kill counter - 8 Bits
// 11039760 -> 11039767 - Blue kill counter - 8 Bits

/* === ID Dictionary === */
// 11038900 - Chillout Init Script
// 1038900 - Chillout Staging Area Region
// 1038901 - Chillout Region
// 11038901 - Chillout Give Team Change Items
// 11038902 - Chillout Remove Team Change Items
// 11038903 - Chillout Staging Area Auto-Invade
// 1038902 - Chillout Staging Area Auto-Invade Region
// 11038904 - Chillout Return To Firelink Script
// 1038903 - Chillout Return To Firelink Bonfire
// 11038905 - Chillout Join game Script
// 1038904 - Chillout Join Game Bonfire
// 1038905 - Chillout Join Game Red Warp
// 1038906 - Chillout Join Game Blue Warp
// 11038906 - Chillout Arena No Dead Apply
// 11038907 - Chillout Staging Area Invincibility
// 11038908 - Chillout Offline Kick Out
// 1038907 - Chillout Map Collision
// 11038909 - Chillout give lobby summon sign and fingers
// 11038910 - Chillout enforce red team id
// 1038908 - Chillout Red Return To Lobby Bonfire
// 1038909 - Chillout Blue Return To Lobby Bonfire
// 1038910 - Chillout Return To Lobby Target Region
// 11038911 - Chillout Return to Lobby: Red
// 11038912 - Chillout Return to Lobby: Blue
// 11038913 - Chillout 'On Death' Handler
// 11038914 - Chillout 'On Respawn' Handler
// 1038920 -> 1038924 - Red Team Respawn Points
// 1038925 -> 1038929 - Blue Team Respawn Points
// 1038913 - Chillout Game Over Return Target Region
// 11038920 - Chillout Red Lose Flag
// 11038921 - Chillout Red Lose Script
// 11038945 - Chillout Blue Lose Flag
// 11038946 - Chillout Blue Lose Script
// 11038948 - Chillout Give Hollowing Item
// 11038949 - Chillout Remove Hollowing Item
// 11038950 - Chillout Remove Arena Speff Auto-Invade Fix
// 11038954 - Chillout Respawn Sync'd Speff Remover
// 11038952 - Chillout Kill Counter
// 11038923 - Chillout Kill Threshold Messages
// 1038998 - Ladder 00
// 1038999 - Ladder 01
// 11038990 -> 11038993 - Ladder Flags
// 11038960 - Chillout Red On Death Kill Count
// 11038961 - Chillout Blue On Death Kill Count


/* Chillout Init General */
Event(11038900, Default, function() {
    
    /* Initialize some variables, only the host does this. */
    SkipIfMultiplayerState(5, MultiplayerState.Client);
    ClearEventValue(11039720, 5); // Clear randomize respawn flags
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038920, OFF);  // Reset red lose flag
    SetEventFlag(11038945, OFF);  // Reset blue lose flag
    
    /* Start arena scripts, but only once we enter the lobby. */
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038900); // Don't init LK arena unless we are in the staging area (or map)
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038901);
    IfConditionGroup(MAIN, PASS, OR_01);
    InitializeEvent(0, 11038901, 0); // Give team change items while in staging area
    InitializeEvent(0, 11038902, 0); // Remove team change items if outside staging area
    InitializeEvent(0, 11038903, 0); // Auto-Invade area
    InitializeEvent(0, 11038904, 0); // Return to Firelink
    InitializeEvent(0, 11038905, 0); // Join game
    InitializeEvent(0, 11038906, 0); // Arena No Dead
    InitializeEvent(0, 11038907, 0); // Staging Area Invincibility
    InitializeEvent(0, 11038908, 0); // Offline Kick Out                              // DEBUG!!!
    InitializeEvent(0, 11038909, 0); // Give lobby summon sign and dried fingers
    InitializeEvent(0, 11038910, 0); // Enforce red team id
    InitializeEvent(0, 11038911, 0); // Return to lobby: Red
    InitializeEvent(0, 11038912, 0); // Return to lobby: Blue
    InitializeEvent(0, 11038913, 0); // 'On Death' Handler
    InitializeEvent(0, 11038914, 0); // 'On Respawn' Handler
    InitializeEvent(0, 11038948, 0); // Give Hollowing Item
    InitializeEvent(0, 11038949, 0); // Remove Hollowing Item
    InitializeEvent(0, 11038950, 0); // Remove Arena Speff Auto-Invade Fix
    InitializeEvent(0, 11038954, 0); // Synced Respawn Speff Remover
    
    InitializeEvent(0, 11038922, 0); // Red Kill Counter
    InitializeEvent(0, 11038923, 0); // Red Kill Threshold Messages
    InitializeEvent(0, 11038921, 0); // Red Lose
    InitializeEvent(0, 11038960, 0); // Red On Death Kill Count
    
    InitializeEvent(0, 11038924, 0); // Blue Kill Counter
    InitializeEvent(0, 11038925, 0); // Blue Kill Threshold Messages
    InitializeEvent(0, 11038946, 0); // Blue Lose
    InitializeEvent(0, 11038961, 0); // Blue On Death Kill Count
    
    /* Teleporters */
    InitializeEvent(0, 11039905, 1033080, 1033081); // Chillout Teleporter Interact #1
    InitializeEvent(0, 11039906, 1033082, 1033083); // Chillout Teleporter Trigger #1
    InitializeEvent(1, 11039905, 1033084, 1033085); // Chillout Teleporter Interact #2
    InitializeEvent(1, 11039906, 1033086, 1033087); // Chillout Teleporter Trigger #2
    InitializeEvent(2, 11039905, 1033088, 1033089); // Chillout Teleporter Interact #3
    InitializeEvent(2, 11039906, 1033090, 1033091); // Chillout Teleporter Trigger #3
    
    /* Powerups */
    InitializeEvent(0, 11039901, 9010, 9500); // Give SP Ammo Handler
    InitializeEvent(0, 11039902, 0);          // Remove last speical arrow bugfix
    InitializeEvent(0, 11039900, 1038950, 1038951, 10030160, 9010, 4500); // Powerup 01  - Ammo
    InitializeEvent(1, 11039900, 1038952, 1038953, 10030167, 9027, 2700); // Powerup 02  - Rage
    InitializeEvent(2, 11039900, 1038954, 1038955, 10030161, 9021, 900); // Powerup 03   - Heal
    InitializeEvent(3, 11039900, 1038956, 1038957, 10030163, 9023, 1350); // Powerup 04  - Stamina
    InitializeEvent(4, 11039900, 1038958, 1038959, 10030168, 9028, 3600); // Powerup 05  - Karma
    InitializeEvent(5, 11039900, 1038960, 1038961, 10030166, 9026, 4500); // Powerup 06  - Damage
    InitializeEvent(6, 11039900, 1038962, 1038963, 10030173, 9033, 3600); // Powerup 07  - Resonance
    InitializeEvent(7, 11039900, 1038964, 1038965, 10030175, 9035, 4500); // Powerup 08  - Speed
    InitializeEvent(8, 11039900, 1038966, 1038967, 10030162, 9022, 1350); // Powerup 09  - Regen
    InitializeEvent(9, 11039900, 1038968, 1038969, 10030171, 9031, 3600); // Powerup 10  - Flame
    InitializeEvent(10, 11039900, 1038970, 1038971, 10030161, 9021, 900); // Powerup 11  - Heal
    InitializeEvent(11, 11039900, 1038972, 1038973, 10030163, 9023, 1350); // Powerup 12 - Stamina
    InitializeEvent(12, 11039900, 1038974, 1038975, 10030165, 9025, 4500); // Powerup 13 - Defense
    InitializeEvent(13, 11039900, 1038976, 1038977, 10030164, 9024, 3600); // Powerup 14 - Poise
    InitializeEvent(14, 11039900, 1038978, 1038979, 10030162, 9022, 1350); // Powerup 15 - Regen
    
    /* Helper NPC */
    SetCharacterInvincibility(1031000, Enabled);
    WarpCharacterAndCopyFloor(1031000, TargetEntityType.Area, 1031012, -1, 10000);
    
    /* Welcome! */
    WaitFixedTimeSeconds(3.25);
    DisplayStatusMessage(10010664, Enabled);  // Lobby entrance message
});



/* Chillout Give Team Change Items */
// If we are in the staging area, and we are NOT the host, give the team changing items.
Event(11038901, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038900);
    IfMultiplayerState(AND_01, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.DoesntOwn);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(5050);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Remove Team Change Items */
// If we are outside the staging area, remove team change items.
Event(11038902, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038900);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 265, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 266, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 265, 1);
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Give Hollowing Item */
// If we are in the invasion area, and we are singleplayer, and we are team 1 (alive), give hollow orb
Event(11038948, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038902);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.DoesntOwn);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterHasSpeffect(AND_01, 10000, 4610, false);
    IfCharacterHasSpeffect(AND_01, 10000, 4613, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5058);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Remove Hollowing Item */
// If we are ouside the invasion area, are in multiplayer, are hollow, or have arena speffs, we remove the hollow orb
Event(11038949, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Outside, 10000, 1038902);
    IfMultiplayerState(OR_01, MultiplayerState.Multiplayer);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 269, OwnershipState.Owns);
    IfCharacterHasSpeffect(OR_01, 10000, 4610, true);
    IfCharacterHasSpeffect(OR_01, 10000, 4613, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Clear Arena Speff 3 Frame Delay Fix */
// There is a delay betweeen clearing 4610 and returning to proper human/hollow, so I clear the effects to sort out a minor issue. Not critical.
Event(11038950, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038902);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 4610);
    WaitFixedTimeSeconds(0.05);
    ClearSpeffect(10000, 4613);
    
    EndUnconditionally(EventEndType.Restart);
});
    

/* Chillout Staging Area Auto-Invade Script */
// Small area that players can stand in and it will constantly search for players to invade. Also clears arena speff so you can invade while hollow
Event(11038903, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038902);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1.5);
    
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038902);
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetSpeffect(10000, 11);
    WaitFixedTimeSeconds(20);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Chillout Return to Firelink */
/* Ends multiplayer session. For hosts it returns you to firelink and for phantoms it black crystals you out */
Event(11038904, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038903, 180, 100, 2, 10010608, ReactionType.All, 0);
    RotateCharacter(10000, 1038903);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    SkipIfMultiplayerState(2, MultiplayerState.Client); // Skip to ::1
    WarpPlayer(10, 2, 1029100);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetSpeffect(10000, 7);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Join Game */
/* Bonfire that warps you into the actual map play area. */
Event(11038905, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfActionButton(MAIN, TargetEntityType.Object, 1038904, 180, 100, 2, 10010601, ReactionType.All, 0);
    RotateCharacter(10000, 1038904);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    
    //PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038906, 10, 3); // DEBUG!!!
    //EndUnconditionally(EventEndType.Restart);                                       // DEBUG!!!
    
    SkipIfMultiplayerState(2, MultiplayerState.Multiplayer); // Skip to ::1
    DisplayGenericDialog(10010609, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01); // Skip to ::2
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038906, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_02); // Skip to ::3
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038905, 10, 3);
    EndUnconditionally(EventEndType.Restart);
    // ::3
    EndUnconditionally(EventEndType.Restart);
});


/* Chillout Arena No Dead */
/* Applies the Arena No Dead effect to you while you are in the arena. Respawns are handled by scripts so we don't want people dieing. */
Event(11038906, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038900);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038901);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1038902);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Staging Area Invincibility */
/* Grants full invincibility while in the staging area. Also removes it when you exit. Additionally, invincibility is granted if the player is currently in a 'dead' state in the arena play area. */
Event(11038907, Default, function() {
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(1);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1038901);
    IfCharacterHasSpeffect(AND_02, 10000, 9100, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02); // Skip to ::2
    SetCharacterInvincibility(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
    // ::2
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038900);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01); // Skip to ::1
    SetCharacterInvincibility(10000, Disabled);
    EndUnconditionally(EventEndType.Restart);
    // ::1
    SetCharacterInvincibility(10000, Enabled);
    BonfirelikeRecovery();
    SetSpeffect(10000, 9112);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Play Area Offline Kickout */
/* If you are in the Chillout play area (the actual Chillout map) and you are in singleplayer, kick the player to the staging area. */
Event(11038908, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038901);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(3);
    WarpPlayer(10, 2, 1020997);
});

/* Chillout Give Lobby Items */
// If we are in the staging area, and we are the host, give lobby summon sign and lobby fingers
Event(11038909, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038900);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 267, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 268, OwnershipState.DoesntOwn);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemLot(5055);
    WaitFixedTimeSeconds(1.5);
    AwardItemLot(5060);
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Enforce Red Team ID */
// Both invaders and red summons should have their team immideately changed to 6. Prevents friendly fire.
Event(11038910, Default, function() {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038900);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1038901);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_01, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterTeamType(10000, TeamType.Enemy);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Red Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Red base edition. */
Event(11038911, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038908, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038908);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038910, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Blue Return To Lobby */
/* Bonfire that warps you from the play area back to the lobby. Blue base edition. */
Event(11038912, Default, function() {
    SetNetworkSyncState(Disabled); // Don't sync this becasue it invovles time delayed moving of players
    IfCharacterHasSpeffect(AND_01, 10000, 9105, false);  // Can't take either flag into the lobby
    IfCharacterHasSpeffect(AND_01, 10000, 9106, false);
    IfActionButton(AND_01, TargetEntityType.Object, 1038909, 180, 100, 2, 10010603, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1038909);
    ForceAnimationPlayback(10000, 7114, false, false, false);
    WaitFixedTimeSeconds(0.7);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 17, 90021);
    WaitFixedTimeSeconds(1.5);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038910, 10, 3);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout 'On Death' Handler */
/* When a player reaches 5 hp, and does not yet have the arena dead speff or arena respawn speff, we put them into 'arena dead' state for 10 seconds. Then when the 10 seconds is up we flag them for respawn via speff. */
Event(11038913, Default, function() {
    SetNetworkSyncState(Disabled); //Don't sync this because it displays a message. The part that needs sync (status changes) is handled by the script below.
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038901);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9100);    // Set "Dead" Speff
    SetSpeffect(10000, 9111);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on death
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    DisplayGenericDialog(10010617, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);

    //RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    //SetSpecialAnimations(10000, 0, -1, -1, -1, -1);   // Force animation reset
    //SetSpecialAnimations(10000, -1, -1, -1, -1, -1);  // Hopefully this isn't needed anymore. (??) It should help with syncing to not have it I hope.
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Red On Death Kill Counter */
/* Description */
Event(11038960, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If red team member dead and has 'kill count flag'
    IncrementEventValue(11039750, 8, 30);  // Increment blue score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Blue On Death Kill Counter */
/* Description */
Event(11038961, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9111, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 19900033); // Disable score tracking if FFA
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfConditionGroup(AND_02, PASS, OR_01);
    IfConditionGroup(AND_02, PASS, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);  // If blue team member dead and has 'kill count flag'
    IncrementEventValue(11039760, 8, 30);  // Increment red score
    ClearSpeffect(10000, 9111);            // Remove kill count flag speff
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Sync'd Respawn Speff Remvoer */
/* When a player dies, we remove any speffs for powerups or status effects. This is synced so as to prevent phantom visual effects for other players. */
Event(11038954, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9100, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs (except kamikaze)
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    ClearSpeffect(10000, 510);  // Clear various magic buffs (mostly spells)
    ClearSpeffect(10000, 530);
    ClearSpeffect(10000, 540);
    ClearSpeffect(10000, 541);
    ClearSpeffect(10000, 550);
    ClearSpeffect(10000, 555);
    ClearSpeffect(10000, 570);
    ClearSpeffect(10000, 571);
    ClearSpeffect(10000, 572);
    ClearSpeffect(10000, 573);
    ClearSpeffect(10000, 574);
    ClearSpeffect(10000, 610);
    ClearSpeffect(10000, 611);
    ClearSpeffect(10000, 612);
    ClearSpeffect(10000, 620);
    ClearSpeffect(10000, 640);
    ClearSpeffect(10000, 645);
    ClearSpeffect(10000, 1000);
    ClearSpeffect(10000, 1010);
    ClearSpeffect(10000, 1020);
    ClearSpeffect(10000, 1024);
    ClearSpeffect(10000, 1025);
    ClearSpeffect(10000, 1040);
    ClearSpeffect(10000, 1050);
    ClearSpeffect(10000, 1060);
    ClearSpeffect(10000, 1070);
    ClearSpeffect(10000, 1080);
    ClearSpeffect(10000, 1081);
    ClearSpeffect(10000, 1082);
    ClearSpeffect(10000, 1083);
    ClearSpeffect(10000, 1120);
    ClearSpeffect(10000, 1130);
    ClearSpeffect(10000, 1140);
    ClearSpeffect(10000, 1150);
    ClearSpeffect(10000, 1155);
    ClearSpeffect(10000, 1156);
    ClearSpeffect(10000, 1160);
    ClearSpeffect(10000, 1170);
    ClearSpeffect(10000, 1090);
    ClearSpeffect(10000, 1360);
    ClearSpeffect(10000, 1061);
    ClearSpeffect(10000, 1435);
    ClearSpeffect(10000, 1436);
    ClearSpeffect(10000, 1800);
    
    ClearSpeffect(10000, 3040); // Clear various item buffs
    ClearSpeffect(10000, 3150);
    ClearSpeffect(10000, 3151); // Lloyds lol
    ClearSpeffect(10000, 720); // Karmic Reflection effects x3
    ClearSpeffect(10000, 721);
    ClearSpeffect(10000, 722);
    ClearSpeffect(10000, 730);
    ClearSpeffect(10000, 731);
    ClearSpeffect(10000, 3160);
    ClearSpeffect(10000, 3170);
    ClearSpeffect(10000, 3190);
    ClearSpeffect(10000, 3191);
    
    SetSpeffect(10000, 1303); // Cure all status effects 
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout 'On Respawn' Handler */
/* If a player has the 'arena respawn' speff we do a respawn. Also add the 'post respawn' speff to prevent a double respawn due to emevd nonsense. */
Event(11038914, Default, function() {
    SetNetworkSyncState(Disabled); // Do not sync this since we are applying bonfire recovery and doing a cutscene warp
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1038901);
    IfCharacterHasSpeffect(AND_01, 10000, 9101, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9102, false);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01); // I don't know why I wrote it this way. ???
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(10000, 9102);   // Add 'post respawn' speff
    ClearSpeffect(10000, 9100); // Clear 'dead' speff
    ClearSpeffect(10000, 9101); // Clear 'respawn' spefff
    
    BonfirelikeRecovery();      // Recovery
    SetSpeffect(10000, 9127);   // Repair all equipment
    SetSpeffect(10000, 9108);   // Respawn hide effect. Makes you invis for 1 second.
    
    WaitFixedTimeFrames(1);     // Wait 1 frame for the chr.esd state to update
    
    // Pick a respawn point randomly
    ClearEventValue(11039720, 5);
    RandomlySetEventFlagInRange(11039720, 11039724, ON);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11039726); // FFA FlipFlop Spawn Flag
    SetEventFlag(11039726, ON);
    SkipUnconditionally(1);
    SetEventFlag(11039726, OFF);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterHasSpeffect(AND_03, 10000, 9416, true);                // If FFA mode ...
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11039726); // Random select team spawn
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(16, PASS, AND_03);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    SkipIfConditionGroupStateUncompiled(11, PASS, OR_01);      // Skip to ::1
    // Respawns for Red Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038920, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038921, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038922, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038923, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038924, 10, 3); // Warp to respawn point
    // ::1
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    SkipIfConditionGroupStateUncompiled(10, PASS, OR_02);      // Skip to ::2
    // Respawns for Blue Team
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039720);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038925, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039721);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038926, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039722);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038927, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039723);   
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038928, 10, 3); // Warp to respawn point
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11039724);    
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038929, 10, 3); // Warp to respawn point
    // ::2
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);        // 'Stand up' animation after respawn
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Red Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038922, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039750, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038945);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038945, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Red Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038923, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010622, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010623, 0);
    IfEventValue(MAIN, 11039750, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010624, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038945); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038920);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Blue Kill Counter */
/* Host counts kills for each team. First to limit is flagged to win. */
Event(11038924, Default, function() {
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(AND_01, 11039760, 8, ComparisonType.GreaterOrEqual, 30);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11038920);
    IfConditionGroup(MAIN, PASS, AND_01); // If blue team is not already flagged for loss, and red teams kill count is over 30
    
    SetEventFlag(11038920, ON); // Flag blue team loss
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Blue Kill Threshold Messages */
/* When the kill counts reach certain values we display a message letting everyone know whos in the lead. */
Event(11038925, Default, function() {
    SetNetworkSyncState(Disabled); // Just reading event flags and displaying messages.
    //EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client); // Only host checks kill counts
    
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 10);
    DisplayMessage(10010626, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 20);
    DisplayMessage(10010627, 0);
    IfEventValue(MAIN, 11039760, 8, ComparisonType.GreaterOrEqual, 25);
    DisplayMessage(10010628, 0);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038945); 
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11038920);
    IfConditionGroup(MAIN, PASS, OR_01);  // Wait for game to end before starting again
    
    WaitFixedTimeSeconds(10); // Delay to allow next round to start
    
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Red Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038921, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038920);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038913, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038920, OFF);  // Reset red lose flag
    SetEventFlag(11038945, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Alive);
    IfCharacterType(OR_02, 10000, TargetType.WhitePhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});

/* Chillout Blue Team Lose */
/* Display victory/loss, give rewards, reset game and returns players to lobby. */
Event(11038946, Default, function() {
    SetNetworkSyncState(Disabled); // Should be fine.
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11038945);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(OR_01, 10000, TargetType.Invader);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    DisplayBanner(TextBannerType.YouLose);
    SkipUnconditionally(1);
    DisplayBanner(TextBannerType.YouWin);
    
    WaitFixedTimeSeconds(5.0);

    BonfirelikeRecovery();
    ClearSpeffect(10000, 9100);  // Clear all game state effects
    ClearSpeffect(10000, 9101);
    ClearSpeffect(10000, 9102);
    ClearSpeffect(10000, 9105);
    ClearSpeffect(10000, 9106);
    
    ClearSpeffect(10000, 9021);  // Remove all arena powerup buffs
    ClearSpeffect(10000, 9022);
    ClearSpeffect(10000, 9023);
    ClearSpeffect(10000, 9024);
    ClearSpeffect(10000, 9025);
    ClearSpeffect(10000, 9026);
    ClearSpeffect(10000, 9028);
    ClearSpeffect(10000, 9027);
    ClearSpeffect(10000, 9029);
    ClearSpeffect(10000, 9030);
    ClearSpeffect(10000, 9031);
    ClearSpeffect(10000, 9032);
    ClearSpeffect(10000, 9033);
    ClearSpeffect(10000, 9034);
    ClearSpeffect(10000, 9035);
    ClearSpeffect(10000, 9041);
    
    /* Return to lobby and ready for next match */
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, 1038913, 10, 3);
    ClearEventValue(11039750, 8); // Clear red kill counter
    ClearEventValue(11039760, 8); // Clear red kill counter
    SetEventFlag(11038920, OFF);  // Reset red lose flag
    SetEventFlag(11038945, OFF);  // Reset blue lose flag
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated); // Prevent fall animation lol
    
    /* Award loot */
    WaitFixedTimeSeconds(3.0);
    AwardItemsIncludingClients(5005);
    AwardItemsIncludingClients(5005);
    IfCharacterType(OR_02, 10000, TargetType.Invader);
    IfCharacterType(OR_02, 10000, TargetType.BlackPhantom);
    SkipIfConditionGroupStateUncompiled(1, PASS, OR_02);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(5005);
    EndUnconditionally(EventEndType.Restart);
});
